#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=5_1.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;Parted Magic - fix docs
;merge filelist arrays and check for duplicates
;ubuntu, knoppix...
;sync separate procedure
;advanced menu


#cs ----------------------------------------------------------------------------
 AutoIt Version: 3.2.10.0
 Author:         Ilko
 Version:		 0.2.3
 Credits: jaclaz, cdob, wimb and porear from MSFN forum for their continous help and work on Installing XP from USB
 as well as everyone, who contributed to the project with ideas, requests or feedback.
 
 Thanks to UglyBob, ptrex, SmOke_N, aec and ezzetabi from AutoIt forum for their excellent AutoIt script examples, parts of which were used.
 Thanks to Anton Bassov for his dummydisk.sys driver and help for reverting its behaviour to rdummy.sys, which makes USB fixed disks to be seen as removabe

The program is released "as is" and is free for redistribution, use or changes as long as original author, credits part and link to the support forum-
http://www.msfn.org/board/Install-XP-from-USB-f157.html 
are CLEARLY mentioned.
Author does not take any responsibility for use or misuse of the program.
#ce ----------------------------------------------------------------------------
;#include <AutoItErrorHandler_UDF.au3>
#include <GUIConstants.au3>
#include <ProgressConstants.au3>
#include <Date.au3>
#include <Array.au3>
#Include <GuiComboBox.au3>
#include <File.au3>
#Include <GuiStatusBar.au3>
#include <String.au3>
Opt("GUIOnEventMode", 1)
Opt("TrayIconHide", 1)
;variables
Global $WinSource="",$SourceVersion,$WinSourceSize=0,$TotalSourceSize=0,$TargetDrive,$VistaSource,$PESource,$PMagicSource, $PMagicSize = 0, $SysLinuxSource, $SysLinuxSize = 0
Global $USBdrives, $VistaSize=0, $PESize=0, $LastGroupUsed, $PrevWinSource="", $NrCpdFiles, $menulst, $TargetSpaceAvail=0, $AMD64=0, $vers, $sp
Global $TempWinSource, $TempPESource, $TempPMSource, $TempVistaSource, $TempSysLinuxSource, $Paused, $targetActive, $logfile, $a, $b, $sync, $dt, $_ScriptDir, $NTFSWarning = 0
$_ScriptDir = @ScriptDir
If StringRight($_ScriptDir, 1) = "\"  Then
	$_ScriptDir= StringTrimRight($_ScriptDir, 1)
EndIf
$dt = StringReplace(_NowCalc(), "/", "", 0)
$dt = StringReplace($dt, ":", "", 0)
$dt = StringReplace($dt, " ", "-", 0)
If FileExists($_ScriptDir & "\WinSetupFromUSB.log") Then
	RunWait(@ComSpec & " /c makecab.exe " & "WinSetupFromUSB.log" & " log.cab", $_ScriptDir, @SW_HIDE)
	FileMove($_ScriptDir & "\log.cab", $_ScriptDir & "\backups\" & $dt & "-log.cab", 8)
	FileDelete($_ScriptDir & "\WinSetupFromUSB.log")
EndIf
HotKeySet("{PAUSE}", "TogglePause")
;HotKeySet("{ESC}", "Quit")
;HotKeySet("{F5}", "PopulateUSBComboBox")
Logging("---------------------------------Program started-----------------------------------------------")
;===================================================================================================
;
;        							  Create GUI
;
;===================================================================================================
;=================================================================================================================================
#Region ### START Koda GUI section ### 
$mainwindow = GUICreate("WinSetupFromUSB 0.2.3", 449, 488, 241, 153)
$SourceDir = GUICtrlCreateButton("Browse", 376, 32, 44, 23)
$Source = GUICtrlCreateInput("", 24, 32, 337, 21)
$RefreshUSB = GUICtrlCreateButton("Refresh", 376, 72, 44, 23)
;$HP_format = GUICtrlCreateButton("HP format tool", 208, 136, 81, 23)
;$PEtoUSB = GUICtrlCreateButton("PEtoUSB", 320, 136, 81, 23)
$RMPrepUSB = GUICtrlCreateButton("RMPrepUSB", 225, 136, 162, 23)
$RemovableRadio = GUICtrlCreateRadio("Removable", 24, 128, 113, 17)
$FixedRadio = GUICtrlCreateRadio("Fixed", 24, 152, 113, 17)
$ComboBoxTarget = GUICtrlCreateCombo("", 24, 72, 337, 25)
$GO = GUICtrlCreateButton("GO", 256, 416, 89, 33)
$EXIT = GUICtrlCreateButton("EXIT", 360, 416, 65, 33)
$BootINILabel1 = GUICtrlCreateLabel("Windows will be installed in:", 24, 224, 135, 15)
$WinTarget = GUICtrlCreateInput("\WINDOWS", 24, 240, 135, 21)
$WinTargetDisk = GUICtrlCreateInput("0", 32, 280, 25, 21)
$WinTargetPartition = GUICtrlCreateInput("1", 112, 280, 25, 21)
$WinTargetDiskLabel = GUICtrlCreateLabel("Disk Nr:", 24, 264, 42, 15)
$WinTargetPartitionLabel = GUICtrlCreateLabel("Partition Nr:", 96, 264, 59, 15)
$AddPECheck = GUICtrlCreateCheckbox("", 200, 240, 17, 17)
$AddPEBrowse = GUICtrlCreateButton(". . .", 384, 240, 33, 21)
$AddPeSource = GUICtrlCreateInput("", 224, 240, 153, 21)
$AddVistaCheck = GUICtrlCreateCheckbox("", 200, 280, 17, 17)
$AddVistaBrowse = GUICtrlCreateButton(". . .", 384, 280, 33, 21)
$AddVistaSource = GUICtrlCreateInput("", 224, 280, 153, 21)
$AddPMagicCheck = GUICtrlCreateCheckbox("", 200, 320, 17, 17)
$AddPMagicBrowse = GUICtrlCreateButton(". . .", 384, 320, 33, 21)
$AddPMagicSource = GUICtrlCreateInput("", 224, 320, 153, 21)
$AddSysLinuxCheck = GUICtrlCreateCheckbox("", 200, 360, 17, 17)
$AddSysLinuxBrowse = GUICtrlCreateButton(". . .", 384, 360, 33, 21)
$AddSysLinuxSource = GUICtrlCreateInput("", 224, 360, 153, 21)
$LabelFormatTarget = GUICtrlCreateGroup("Format USB disk", 192, 112, 233, 65)
$WinTargetAdd = GUICtrlCreateInput("\WINDOWS", 24, 320, 135, 21)
$TargetDiskAdd = GUICtrlCreateInput("1", 40, 360, 25, 21)
$TargetPartitionAdd = GUICtrlCreateInput("3", 112, 360, 25, 21)
$WinTargetAddDisk = GUICtrlCreateLabel("Disk Nr:", 32, 344, 42, 15)
$WinTargetAddPart = GUICtrlCreateLabel("Partition Nr:", 96, 344, 59, 15)
$BootINIAddCheck = GUICtrlCreateCheckbox("Additional entry in BOOT.INI", 24, 304, 154, 15)
$BootINIAdjGroup = GUICtrlCreateGroup("BOOT.INI adjustments", 16, 208, 161, 185)
$ForceTargetGroup = GUICtrlCreateGroup("Force Target disk type", 16, 112, 161, 65)
$OptionallyLabel1 = GUICtrlCreateGroup("You may also add:", 192, 208, 233, 185)
$Label2 = GUICtrlCreateLabel("UBCD4Win/WinBuilder/FLPC", 224, 224, 150, 15)
$Label3 = GUICtrlCreateLabel("Vista/7 setup/PE/RecoveryISO", 224, 264, 160, 15)
$Label4 = GUICtrlCreateLabel("PartedMagic v.>3.0 / Other ISO", 224, 304, 160, 15)
$Label5 = GUICtrlCreateLabel("SysLinux bootsector/distro", 224, 344, 150, 15)
$ProgressAll = GUICtrlCreateProgress(16, 424, 225, 16, $PBS_SMOOTH)
$BootOnlyCheck = GUICtrlCreateCheckbox("Copy setup boot/RC files only", 24, 184, 160, 17)
$qemu = GUICtrlCreateCheckbox("Test in QEMU, use at own risk", 200, 184, 233, 17)
$Label1 = GUICtrlCreateLabel("Windows 2000/XP/2003 Source", 24, 16, 166, 15)
$Label6 = GUICtrlCreateLabel("USB Disk Selection", 24, 56, 171, 15)
$Group2 = GUICtrlCreateGroup("", 16, 8, 409, 97)
;$FileMenu = GUICtrlCreateMenu("&File")
;$HelpMenu = GUICtrlCreateMenu("&Help")
;$AboutItem = GUICtrlCreateMenuitem ("About",$HelpMenu)
;$ExitItem = GUICtrlCreateMenuitem ("Exit",$FileMenu)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

;=================================================================================================================================
$hStatus = _GUICtrlStatusBar_Create($mainwindow, -1, "", $SBARS_TOOLTIPS)
Global $aParts[5] = [40, 90, 355, 400, -1] ;total width is 445
_GUICtrlStatusBar_SetParts($hStatus, $aParts)
_GUICtrlStatusBar_SetTipText ($hStatus, 0, "Current selection in MB")
_GUICtrlStatusBar_SetTipText ($hStatus, 1, "Total space on target disk")
_GUICtrlStatusBar_SetTipText ($hStatus, 2, "File being copied")
_GUICtrlStatusBar_SetTipText ($hStatus, 3, "Number of files copied")
_GUICtrlStatusBar_SetTipText ($hStatus, 4, "Total number of files to be copied")
GUISetOnEvent($GUI_EVENT_CLOSE, "Quit")
GUICtrlSetState($SourceDir, $GUI_FOCUS) ; the focus is on this button
GUICtrlSetOnEvent($SourceDir, "GetSource")
GUICtrlSetTip($SourceDir, "Select Windows source, where folder I386 can be found", "", 0, 1)
GUICtrlSetTip($Source, "Windows source, where folder I386 can be found", "", 0, 1)
GUICtrlSetOnEvent($RefreshUSB, "PopulateUSBComboBox")
GUICtrlSetTip($RefreshUSB, "Refresh USB disks information" & @CRLF & @CRLF & "Only properly formatted disks with active partition will be displayed!", "", 0, 1)
GUICtrlSetOnEvent($RMPrepUSB, "RMPrepUSB")
GUICtrlSetTip($RMPrepUSB, "Format USB disk using RMPrepUSB" & @CRLF & @CRLF & 'Use "Boot as HDD" and "XP Bootable [NTLDR]" options then press "Prepare Drive" button.' _ 
& @CRLF & @CRLF & "All partitions on the USB disk will be lost!" _ 
& @CRLF & @CRLF & "If it is USB hard disk you may use Windows format, but make sure you set active partition" _
& @CRLF & "from disk management!" & @CRLF & @CRLF & "NTFS greatly improves file copy speed.", "", 0, 1)
GUICtrlSetTip($RemovableRadio, "Force selection if for some reason USB disk type was not detected properly" _
& @CRLF & "or you are using filter driver such as Hitachi microdrive filter driver or Dummydisk.sys", "", 0, 1)
GUICtrlSetTip($FixedRadio, "Force selection if for some reason USB disk type was not detected properly" _
& @CRLF & "or you are using filter driver such as Hitachi microdrive filter driver or Dummydisk.sys", "", 0, 1)
GUICtrlSetOnEvent($ComboBoxTarget, "GetComboUSBSelection")
GUICtrlSetTip($ComboBoxTarget, "Only disks with an active partition will be displayed!" & @CRLF & "If your USB disk is not displayed make sure" _
& " it has an active partition and MBR" & @CRLF & " or simply format it with the tools below","", 0, 1)
GUICtrlSetState($GO, $GUI_DISABLE)
GUICtrlSetOnEvent($GO, "Main") 
GUICtrlSetOnEvent($EXIT, "Quit")
GUICtrlSetTip($WinTarget, "Change this if you are going to install Windows to a different folder than \WINDOWS", "", 0, 1)
GUICtrlSetTip($WinTargetDisk, "Disk numeration starts from 0, i.e. your first internal disk is 0", "", 0, 1)
GUICtrlSetTip($WinTargetPartition, "Partition numeration starts from 1, i.e. your first partition is 1", "", 0, 1)
GUICtrlSetOnEvent($AddPECheck, "EnableInputBox")
GUICtrlSetTip($AddPECheck, "Add BartPE/WnBulder/UBCD4Win/WinFLPC/WinPE to the USB disk." & @CRLF & @CRLF _
& "Will copy folders I386 as MININT, PROGRAMS/Program Files, IMAGES, CMDCONS and Setup if found." _
& @CRLF & @CRLF & "If it is UBCD4Win and folder IMAGES exist, only default multiboot options will be added" _
& @CRLF & "Edit UBCD4WIN.LST in partition root to add custom entries.", "", 0, 1)
GUICtrlSetState($AddPEBrowse, $GUI_DISABLE)
GUICtrlSetOnEvent($AddPEBrowse,"GetPESource")
GUICtrlSetTip($AddPEBrowse, "Browse for PE folder." & @CRLF & "Will copy files in root and folders I386 as MININT, PROGRAMS/Program Files, IMAGES and CMDCONS if found." _
& @CRLF & "If it is UBCD4Win and folder IMAGES exist, only default multiboot options will be added." _
& @CRLF & "Edit UBCD4WIN.LST in USB root to add custom entries", "", 0, 1)

GUICtrlSetState($AddPeSource, $GUI_DISABLE)
GUICtrlSetTip($AddVistaCheck, "Add Vista / 7 setup/PE/RecoveryISO to the USB disk.", "", 0, 1)
GUICtrlSetOnEvent($AddVistaCheck, "EnableInputBox")
GUICtrlSetState($AddVistaBrowse, $GUI_DISABLE)
GUICtrlSetOnEvent($AddVistaBrowse,"GetVistaSource")
GUICtrlSetState($AddVistaSource, $GUI_DISABLE)
GUICtrlSetOnEvent($AddPMagicCheck, "EnableInputBox")
GUICtrlSetTip($AddPMagicCheck, "Add PartedMagic to the USB disk. Versions 3.0 and above are supported", "", 0, 1)
GUICtrlSetState($AddPMagicBrowse, $GUI_DISABLE)
GUICtrlSetOnEvent($AddPMagicBrowse,"GetPMagicSource")
GUICtrlSetTip($AddPMagicBrowse, "Click to select where pmagic-3.X.iso can be found." _ 
& @CRLF & "You need to extract pmagic-grub4dos-3.X.iso.zip somewhere and point to its location", "", 0, 1)
GUICtrlSetState($AddPMagicSource, $GUI_DISABLE)
GUICtrlSetOnEvent($AddSysLinuxCheck, "EnableInputBox")
GUICtrlSetTip($AddSysLinuxCheck, "Add SysLinux based Linux distro to the USB disk. Entire contents of your selection will be copied" _
 & @CRLF & "Make sure you don't have existing files/folders with the same names on the USB disk, as script will NOT overwrite them!" & @CRLF _
 & @CRLF & "If source is not selected, then SysLinux bootsector will be made, LDLINUX.SYS copied to root of USB disk," _
& @CRLF &  "and an entry in boot menu added.", "", 0, 1)
GUICtrlSetState($AddSysLinuxBrowse, $GUI_DISABLE)
GUICtrlSetOnEvent($AddSysLinuxBrowse,"GetSysLinuxSource")
GUICtrlSetState($AddSysLinuxSource, $GUI_DISABLE)
GUICtrlSetState($WinTargetAdd, $GUI_DISABLE)
GUICtrlSetTip($TargetDiskAdd, "Disk numeration starts from 0, i.e. your second internal disk is 1", "", 0, 1)
GUICtrlSetState($TargetDiskAdd, $GUI_DISABLE)
GUICtrlSetTip($TargetPartitionAdd, "Partition numeration starts from 1, i.e. your third partition is 3", "", 0, 1)
GUICtrlSetState($TargetPartitionAdd, $GUI_DISABLE)
GUICtrlSetTip($BootINIAddCheck, "Use if you want to have an additional line in BOOT.INI on the USB disk," & @CRLF _
& "so you can launch second part(GUI) of setup from a different disk/partition", "", 0, 1)
GUICtrlSetOnEvent($BootINIAddCheck, "EnableInputBox")
GUICtrlSetTip($BootOnlyCheck, "Use to test bootability or add only Recovery Console","", 0, 1)
GUICtrlSetOnEvent($BootOnlyCheck, "BootOnly")
GUICtrlSetTip($qemu, "Use at your own risk, data loss may occur on ANY of your hard disks!!!" & @CRLF & "Do NOT use if you are not sure what you are doing!" _
& @CRLF & @CRLF &"Note, that results may and will differ from those on real hardware.", "", 0, 1)
GUICtrlSetOnEvent($qemu, "CheckGo")
;GUICtrlSetOnEvent($ExitItem, "Quit")
;GUICtrlSetOnEvent($AboutItem ,"About")

GUISetState(@SW_SHOW)
;===================================================================================================
;
;       							    End GUI
;
;===================================================================================================
$logfile = FileOpen($_ScriptDir & "\WinSetupFromUSB.log", 1)
Logging ("WinSetupFromUSB 0.2.3 started")
Logging ("OS: " & @OSVersion & "  Architecture type: " & @OSArch & " ServicePack: " & @OSServicePack & " OS Language: " & @OSLang)
PopulateUSBComboBox()  

Loop()
Func Loop()
While 1
	If GUICtrlRead($source) = "" And $WinSource <> "" Then 
		$WinSource = ""
		$TempWinSource = ""
		CheckSize()
		CheckGo()
	EndIf
	Sleep(1000)
	$a = StringLeft(GUICtrlRead($WinTarget), 9)
	GUICtrlSetData($WinTarget, $a)
	$b = StringLeft(GUICtrlRead($WinTargetAdd), 9)
	GUICtrlSetData($WinTargetAdd, $b)
WEnd
EndFunc ;==>Loop()

; --------------------------------------------------------------------------------------------------
;
;       							    FUNCTIONS
;
; --------------------------------------------------------------------------------------------------
;===================================================================================================
Func Main()
	Local $Copy[5], $FileList, $SourceList[1][3], $txtsetupsif, $i, $unatout, $unattend, $file, $presetup, $ini, $sl, $src, $dest, $msg
	Local $instsyslin = 0, $aArray, $aArray_new, $DriversPath, $OEMPreinstall, $PMfilename
	DisableMenus(1)
	$sync = 0
	$SourceList[0][0] = 0
	$NrCpdFiles = 0
	GUICtrlSetData($Go, "STOP")
	If GUICtrlRead($FixedRadio) = $GUI_CHECKED And StringInStr($vers, "64") > 0 Then
		MsgBox(16, "Not supported", "Installing x64 versions from USB disks seen as fixed is not supported!" & @CRLF & @CRLF _
		& "If you can rewrite and compile rdummy.sys for 64-bit versions, please contact us at mfsn.org." & @CRLF _
		& "Aborting in 10 seconds...")
		Logging("Fixed disk and x64 found, aborting...")
		Quit()
	EndIf
	If GUICtrlRead($RemovableRadio) = $GUI_CHECKED And $USBdrives[$USBdrives[0][1]][6] = "Fixed" And StringInStr($vers, "64") > 0 Then 
		MsgBox(16, "Hmm...", "Installing x64 versions from USB disks seen as fixed is not supported!" & @CRLF _
		& "Seems you have forced Fixed/Removable selection to be able to continue." & @CRLF _
		& "You really need to know what you are doing..." & @CRLF _
		& "Will continue, but you are on your own.")
		Logging("Fixed disk, forced Removable selection and x64 found, continuing...")
	EndIf
	Logging("Removing TEMP folder")
	_GUICtrlStatusBar_SetText($hStatus,"Removing TEMP folder", 2)
	DirRemove($_ScriptDir & "\TEMP", 1)
	$NrCpdFiles = 0
	If $TotalSourceSize > 0 or GUICtrlRead($AddSysLinuxCheck) = $GUI_CHECKED Then 
			If Checkgrub() = 0 Then
			_GUICtrlStatusBar_SetText($hStatus,"Installing grub4dos", 2)
			InstallGrub()
		EndIf
	EndIf
While 1
	If GUICtrlRead($BootOnlyCheck) = $GUI_CHECKED And $WinSource <> "" Then
		If FileExists($TargetDrive & "$WIN_NT$.~BT") Then
			$msg = MsgBox(48 + 3, "Folder $WIN_NT$.~BT exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF & "CANCEL to return to the main menu")
			If $msg = 6 Then DirMove($TargetDrive & "$WIN_NT$.~BT", $TargetDrive & "$WIN_NT$.~BT.BKP")
			If $msg = 7 Then DirRemove ($TargetDrive & "$WIN_NT$.~BT", 1)
			If $msg = 2 Then ExitLoop
		EndIf
		MakeBT()
		If GUICtrlRead($FixedRadio) = $GUI_CHECKED And StringInStr($vers, "64") = 0 Then
			Logging("Adding lines for rdummy.sys")
			_GUICtrlStatusBar_SetText($hStatus,"Adding lines for rdummy.sys", 2)
			FileCopy($_ScriptDir & "\files\winsetup\rdummy.sy_", $_ScriptDir & "\TEMP\$win_nt$.~ls\i386", 1)
			FileCopy($_ScriptDir & "\files\winsetup\rdummy.sy_", $_ScriptDir & "\TEMP\$win_nt$.~bt", 1)
			If Not IniWrite($txtsetupsif, "SourceDisksFiles", "rdummy.sys", "1,,,,,,4_,4,1,,,1,4") Then 
				MsgBox(16, "Fatal error", "Couldn't write to " & $txtsetupsif & " , will have to abort :(")
				Logging ("Couldn't write to " & $txtsetupsif & " aborting...")
				Quit()
			EndIf			
			IniWrite($txtsetupsif, "BusExtenders.Load", "rdummy", "rdummy.sys")
			IniWrite($txtsetupsif, "BusExtenders", "RDUMMY", '"USB hard disk as removable",files.RDUMMY,RDUMMY')
			IniWriteLine($txtsetupsif, "files.RDUMMY", "rdummy.sys,4")
			IniWriteLine($_ScriptDir & "\TEMP\$win_nt$.~bt\winnt.sif", "GuiRunOnce", '"sc delete rdummy"')
		EndIf
		$FileList = _FileSearch($_ScriptDir & "\TEMP")
		_Quick_Sort($FileList, 1, $FileList[0])
		$SourceList[0][0] += 1
		ReDim $SourceList[$SourceList[0][0] + 1][3]
		$SourceList[0][1] = $FileList[0]
		$SourceList[1][0] = $FileList
		$sl = StringLen($_ScriptDir & "\TEMP")
		$SourceList[1][1] = $sl
		_CopyDirWithProgress($FileList, $TargetDrive, $sl, $FileList[0], 1) 
		Logging("Preparing boot/RC files only completed")
	Else
		If $WinSource <> "" And GUICtrlRead($BootOnlyCheck) = $GUI_UNCHECKED Then
			If FileExists($TargetDrive & "\$WIN_NT$.~BT") + FileExists($TargetDrive & "\$WIN_NT$.~LS") = 2 Then
				$msg = MsgBox(48 + 3, "Folders $WIN_NT$.~BT and $WIN_NT$.~LS were found", "Folders $WIN_NT$.~BT and $WIN_NT$.~LS were found" _
				& @CRLF & @CRLF & "YES to syncronise source with $WIN_NT$.~LS" _
				& @CRLF & "NO to rename them and patch setup and startup files" & @CRLF & "CANCEL to delete them")
				If $msg = 7 Then
					Logging("Renaming ~BT and ~LS folders and patching setup and startup files")
					_GUICtrlStatusBar_SetText($hStatus,"Renaming ~BT and ~LS folders and patching setup and startup files", 2)
					PatchSrc()
				EndIF
				If $msg = 6 Then
					Logging("Syncronising with source")
					_GUICtrlStatusBar_SetText($hStatus,"Syncronising with source", 2) 
					$sync = 1
				EndIf
				If $msg = 2 Then 
					DirRemove($TargetDrive & "$WIN_NT$.~BT", 1)
					DirRemove($TargetDrive & "$WIN_NT$.~LS", 1)
				EndIf
			EndIf
			If FileExists($TargetDrive & "\$WIN_NT$.~BT") + FileExists($TargetDrive & "\$WIN_NT$.~LS") = 1 Then
				MsgBox(48 + 3, "Orphan folder $WIN_NT$.~BT or $WIN_NT$.~LS was found", "Orphan folder $WIN_NT$.~BT or $WIN_NT$.~LS was found" _
				& @CRLF & "Renaming it to .BAK", 5)
				Logging("Orphan folder $WIN_NT$.~BT or $WIN_NT$.~LS was found, renaming to .BAK")
				If FileExists($TargetDrive & "\$WIN_NT$.~BT") Then DirMove($TargetDrive & "\$WIN_NT$.~BT", $TargetDrive & "\$WIN_NT$.~BT.BAK", 1)
				If FileExists($TargetDrive & "\$WIN_NT$.~LS") Then DirMove($TargetDrive & "\$WIN_NT$.~BT", $TargetDrive & "\$WIN_NT$.~LS.BAK", 1)
			EndIf
			If $sync <> 1 Then
				If Not FileExists($_ScriptDir & "\TEMP\$win_nt$.~bt") Then MakeBT()
				If StringInStr($sp, "SP2") + StringInStr($sp, "SP3") + StringInStr($sp, "XP") = 0 Then 
					MsgBox(64, "Your source doesn't appear to be XP SP2 or 3", "Your source doesn't appear to be XP SP2 or 3." & @CRLF _
					& "During Text part of setup some compressed files may be deleted." _
					& @CRLF & "After setup you can run the program again to copy just the missing files.")
				EndIf
				$txtsetupsif = $_ScriptDir & "\TEMP\txtsetup.sif"
				If GUICtrlRead($FixedRadio) = $GUI_CHECKED And StringInStr($vers, "64") = 0 Then
					Logging("Adding lines for rdummy.sys")
					_GUICtrlStatusBar_SetText($hStatus,"Adding lines for rdummy.sys", 2)
					FileCopy($_ScriptDir & "\files\winsetup\rdummy.sy_", $_ScriptDir & "\TEMP\$win_nt$.~ls\i386", 1)
					FileCopy($_ScriptDir & "\files\winsetup\rdummy.sy_", $_ScriptDir & "\TEMP\$win_nt$.~bt", 1)
					If Not IniWrite($txtsetupsif, "SourceDisksFiles", "rdummy.sys", "1,,,,,,4_,4,1,,,1,4") Then 
						MsgBox(16, "Fatal error", "Couldn't write to " & $txtsetupsif & " , will have to abort :(")
						Logging ("Couldn't write to " & $txtsetupsif & " aborting...")
						Quit()
					EndIf			
					IniWrite($txtsetupsif, "BusExtenders.Load", "rdummy", "rdummy.sys")
					IniWrite($txtsetupsif, "BusExtenders", "RDUMMY", '"USB hard disk as removable",files.RDUMMY,RDUMMY')
					IniWriteLine($txtsetupsif, "files.RDUMMY", "rdummy.sys,4")
					IniWriteLine($_ScriptDir & "\TEMP\$win_nt$.~bt\winnt.sif", "GuiRunOnce", '"sc delete rdummy"')
				EndIf
				Logging("Adding lines for binifix5.cmd and start64.exe")
				_GUICtrlStatusBar_SetText($hStatus,"Adding lines for ren_fold.cmd and binifix5.cmd", 2)
				If $AMD64 = 0 Then
					FileCopy($_ScriptDir & "\files\winsetup\binifix5.cmd", $_ScriptDir & "\TEMP\$win_nt$.~ls\i386", 1)
					IniWrite($txtsetupsif, "SourceDisksFiles", "binifix5.cmd", "1,,,,,,,2,0,0")
					;FileCopy($_ScriptDir & "\files\winsetup\undoren.cmd", $_ScriptDir & "\TEMP\$win_nt$.~ls\i386", 1) 
				Else
					FileCopy($_ScriptDir & "\files\winsetup\binifix5.cmd", $_ScriptDir & "\TEMP\$win_nt$.~ls\amd64", 1)
					IniWrite($txtsetupsif, "SourceDisksFiles", "binifix5.cmd", "1,,,,,,,82,0,0")
					FileCopy($_ScriptDir & "\files\winsetup\start64.exe", $_ScriptDir & "\TEMP\$win_nt$.~ls\amd64", 1)
				EndIf
				Logging("Preparing ~BT folder and boot files")
				_GUICtrlStatusBar_SetText($hStatus,"Preparing ~BT folder and boot files", 2)
				$SourceList[0][0] += 1
				$FileList = _FileSearch($_ScriptDir & "\TEMP")
				_Quick_Sort($FileList, 1, $FileList[0])
				$SourceList[0][1] += $FileList[0]
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$sl = StringLen($_ScriptDir & "\TEMP")
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive
				;boot files and root done
			EndIf
			Logging("Preparing ~LS folder")
			_GUICtrlStatusBar_SetText($hStatus,"Preparing ~LS folder", 2)
			$SourceList[0][0] += 1
			ReDim $SourceList[$SourceList[0][0] + 1][3]
			$FileList = _FileSearch($WinSource & "\I386")
			_Quick_Sort($FileList, 1, $FileList[0])
			$sl = StringLen($WinSource & "\I386")
			$SourceList[0][1] += $FileList[0]
			$SourceList[$SourceList[0][0]][0] = $FileList
			$SourceList[$SourceList[0][0]][1] = $sl
			$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\$WIN_NT$.~LS\I386"
			;check for x64 and add AMD64 folder
			If $AMD64 = 1 Then
				$SourceList[0][0] += 1
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$FileList = _FileSearch($WinSource & "\AMD64")
				_Quick_Sort($FileList, 1, $FileList[0])
				$sl = StringLen($WinSource & "\AMD64")
				$SourceList[0][1] += $FileList[0]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\$WIN_NT$.~LS\AMD64"
			EndIf
			;BTS OEM folder
			If FileExists($WinSource & "\OEM\") Then
				$SourceList[0][0] += 1
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$FileList = _FileSearch($WinSource & "\OEM")
				_Quick_Sort($FileList, 1, $FileList[0])
				$sl = StringLen($WinSource & "\OEM")
				$SourceList[0][1] += $FileList[0]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\OEM"
			EndIf
			;TAG files from root
			$SourceList[0][0] += 1
			$FileList = _FileSearch($WinSource, "WIN*.*", 1, Default, False)
			_Quick_Sort($FileList, 1, $FileList[0])
			$SourceList[0][1] += $FileList[0]
			ReDim $SourceList[$SourceList[0][0] + 1][3]
			$SourceList[$SourceList[0][0]][0] = $FileList
			$sl = StringLen($WinSource)
			$SourceList[$SourceList[0][0]][1] = $sl
			$SourceList[$SourceList[0][0]][2] = $TargetDrive
			;$OEM$ folder
			If FileExists($WinSource & "\$OEM$\") Then 
				$SourceList[0][0] += 1
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$FileList = _FileSearch($WinSource & "\$OEM$")
				_Quick_Sort($FileList, 1, $FileList[0])
				$sl = StringLen($WinSource & "\$OEM$")
				$SourceList[0][1] += $FileList[0]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\$WIN_NT$.~LS\$OEM$"
			EndIf
			;cmpnents
			If FileExists($WinSource & "\cmpnents\") Then 
				$SourceList[0][0] += 1
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$FileList = _FileSearch($WinSource & "\cmpnents")
				_Quick_Sort($FileList, 1, $FileList[0])
				$sl = StringLen($WinSource & "\cmpnents")
				$SourceList[0][1] += $FileList[0]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\$WIN_NT$.~LS\cmpnents"
			EndIf
			;printers 2003
			If FileExists($WinSource & "\printers\") Then 
				$SourceList[0][0] += 1
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$FileList = _FileSearch($WinSource & "\printers")
				_Quick_Sort($FileList, 1, $FileList[0])
				$sl = StringLen($WinSource & "\printers")
				$SourceList[0][1] += $FileList[0]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\$WIN_NT$.~LS\printers"
			EndIf
			;boot.ini
			If $sync <> 1 Then
				If Not FileExists($TargetDrive & "\BOOT.INI") Then
					Logging("Preparing BOOT.INI")
					_GUICtrlStatusBar_SetText($hStatus,"Preparing BOOT.INI", 2)
					IniWriteSection($TargetDrive & "\BOOT.INI", "Boot Loader", "Timeout=5" & @LF & "Default=multi(0)disk(0)rdisk(" & GUICtrlRead($WinTargetdisk) + 1 _
					& ")partition(" & GUICtrlRead($WinTargetPartition) & ")" & GUICtrlRead($WinTarget))
					IniWriteSection($TargetDrive & "\BOOT.INI", "Operating Systems", "multi(0)disk(0)rdisk(" & GUICtrlRead($WinTargetDisk) + 1 _
					& ")partition(" & GUICtrlRead($WinTargetPartition) & ")" & GUICtrlRead($WinTarget) & "=" & '"Second part of' & StringReplace($vers, "windows", "") _
					& " setup from hd " & GUICtrlRead($WinTargetdisk) & " part " & GUICtrlRead($WinTargetPartition) & '" /FASTDETECT')
					If GUICtrlRead($BootINIAddCheck) = $GUI_CHECKED Then
						Logging("Additional line to boot.ini")
						IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems", "multi(0)disk(0)rdisk(" & GUICtrlRead($TargetDiskAdd) + 1 _
						& ")partition(" & GUICtrlRead($TargetPartitionAdd) & ")" & GUICtrlRead($WinTargetAdd), '"Second part of' & StringReplace($vers, "windows", "") _
						& " setup from hd " & GUICtrlRead($TargetDiskAdd) & " part " & GUICtrlRead($TargetPartitionAdd) & '" /FASTDETECT')
					EndIf
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems",'c:\="-------------------------"')
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems",'c:\="Try entries below if getting HAL.DLL/NTOSKRNL.EXE not found errors"')
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems",'c:\="--------------------------"')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(1)partition(2)\WINDOWS", '"Second part of XP Professional setup from hd 0 part 2" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(1)partition(3)\WINDOWS", '"Second part of XP Professional setup from hd 0 part 3" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(1)partition(4)\WINDOWS", '"Second part of XP Professional setup from hd 0 part 4" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(1)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 1" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(2)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 2" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(3)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 3" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(4)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 4" /FASTDETECT')
				Else
					Logging("Addiing lines to existing boot.ini")
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems", "multi(0)disk(0)rdisk(" & GUICtrlRead($WinTargetDisk) + 1 _
						& ")partition(" & GUICtrlRead($WinTargetPartition) & ")" & GUICtrlRead($WinTarget) & '="Second part of' & StringReplace($vers, "windows", "") _
						& " setup from hd " & GUICtrlRead($WinTargetDisk) & " part " & GUICtrlRead($WinTargetPartition) & '" /FASTDETECT')
					If GUICtrlRead($BootINIAddCheck) = $GUI_CHECKED Then
						Logging("Additional line to boot.ini")
						IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems", "multi(0)disk(0)rdisk(" & GUICtrlRead($TargetDiskAdd) + 1 _
						& ")partition(" & GUICtrlRead($TargetPartitionAdd) & ")" & GUICtrlRead($WinTargetAdd) & '="Second part of' & StringReplace($vers, "windows", "") _
						& " setup from hd " & GUICtrlRead($TargetDiskAdd) & " part " & GUICtrlRead($TargetPartitionAdd) & '" /FASTDETECT')
					EndIf
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems",'c:\="-------------------------"')
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems",'c:\="Try entries below if getting HAL.DLL/NTOSKRNL.EXE not found errors"')
					IniWriteLine($TargetDrive & "\BOOT.INI", "Operating Systems",'c:\="--------------------------"')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(1)partition(2)\WINDOWS", '"Second part of XP Professional setup from hd 0 part 2" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(1)partition(3)\WINDOWS", '"Second part of XP Professional setup from hd 0 part 3" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(1)partition(4)\WINDOWS", '"Second part of XP Professional setup from hd 0 part 4" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(1)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 1" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(2)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 2" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(3)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 3" /FASTDETECT')
					IniWrite($TargetDrive & "\BOOT.INI", "Operating Systems","multi(0)disk(0)rdisk(2)partition(4)\WINDOWS", '"Second part of XP Professional setup from hd 1 part 4" /FASTDETECT')
				EndIf
				;add ntldr to winsetup.lst
				Logging("Preparing winsetup.lst")
				$menulst = FileOpen($TargetActive & "\winsetup.lst", 1)
				FileWriteLine($menulst, @CRLF & "title Second part of " & $vers & " setup")
				FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
				FileWriteLine($menulst, "chainloader (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")/NTLDR")
				FileWriteLine($menulst, "savedefault")
				FileClose($menulst)
			EndIf ;making Win source
		EndIf
		;pesource
		If $PESource <> "" And GUICtrlRead($AddPECheck) = $GUI_CHECKED Then
			If FileExists($TargetDrive & "\minint\") Then
				$msg = MsgBox(48 + 3, "Folder MININT exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF & "CANCEL to return to the main menu")
				If $msg = 6 Then DirMove($TargetDrive & "\minint", $TargetDrive & "\minint.bkp")
				If $msg = 7 Then DirRemove ($TargetDrive & "\minint", 1)
				If $msg = 2 Then ExitLoop
			EndIf
			;minint
			Logging("Preparing PE source")
			_GUICtrlStatusBar_SetText($hStatus,"Preparing PE source", 2)
			$SourceList[0][0] += 1
			$FileList = _FileSearch($PESource & "\I386")
			_Quick_Sort($FileList, 1, $FileList[0])
			$SourceList[0][1] += $FileList[0]
			ReDim $SourceList[$SourceList[0][0] + 1][3]
			$SourceList[$SourceList[0][0]][0] = $FileList
			$sl = StringLen($PESource & "\I386")
			$SourceList[$SourceList[0][0]][1] = $sl
			$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\minint"
			;Setup
			If FileExists($PESource & "\Setup\") Then
				If FileExists($TargetDrive & "\Setup\") Then
					$msg = MsgBox(48 + 3, "Folder Setup exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF _
					& "CANCEL to return to the main menu")
					If $msg = 6 Then DirMove($TargetDrive & "\Setup", $TargetDrive & "\Setup.BKP")
					If $msg = 7 Then DirRemove ($TargetDrive & "\Setup", 1)
					If $msg = 2 Then ExitLoop
				EndIf
				$SourceList[0][0] += 1
				$FileList = _FileSearch($PESource & "\Setup")
				_Quick_Sort($FileList, 1, $FileList[0])
				$SourceList[0][1] += $FileList[0]
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$sl = StringLen($PESource & "\Setup")
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\Setup"
			EndIf
			;programs
			If FileExists($PESource & "\programs\") Then
				If FileExists($TargetDrive & "\programs\") Then
					$msg = MsgBox(48 + 3, "Folder PROGRAMS exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF _
					& "CANCEL to return to the main menu")
					If $msg = 6 Then DirMove($TargetDrive & "\programs\", $TargetDrive & "\programs.BKP\")
					If $msg = 7 Then DirRemove ($TargetDrive & "\programs\", 1)
					If $msg = 2 Then ExitLoop
				EndIf
				$SourceList[0][0] += 1
				$FileList = _FileSearch($PESource & "\programs")
				_Quick_Sort($FileList, 1, $FileList[0])
				$SourceList[0][1] += $FileList[0]
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$sl = StringLen($PESource & "\programs")
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\programs"
			ElseIf FileExists($PESource & "\program files\") Then
				If FileExists($TargetDrive & "\program files\") Then
					$msg = MsgBox(48 + 3, "Folder PROGRAM FILES exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF _
					& "CANCEL to return to the main menu")
					If $msg = 6 Then DirMove($TargetDrive & "\program files\", $TargetDrive & "\program files.BKP\")
					If $msg = 7 Then DirRemove ($TargetDrive & "\program files\", 1)
					If $msg = 2 Then ExitLoop
				EndIf
				$SourceList[0][0] += 1
				$FileList = _FileSearch($PESource & "\program files")
				_Quick_Sort($FileList, 1, $FileList[0])
				$SourceList[0][1] += $FileList[0]
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$sl = StringLen($PESource & "\program files")
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\program files"
			EndIf
			;files to root
			$SourceList[0][0] += 1
			$FileList = _FileSearch($PESource, Default, 1, Default, False)
			_Quick_Sort($FileList, 1, $FileList[0])
			$SourceList[0][1] += $FileList[0]
			ReDim $SourceList[$SourceList[0][0] + 1][3]
			$SourceList[$SourceList[0][0]][0] = $FileList
			$sl = StringLen($PESource)
			$SourceList[$SourceList[0][0]][1] = $sl
			$SourceList[$SourceList[0][0]][2] = $TargetDrive
			
			
			;ubcd4win
			If StringInStr(IniRead($PESource & "\I386\system32\OEMINFO.INI", "General", "Model", "" ), "UBCD4Win") > 0 Then
				If FileExists($PESource & "\images\") Then
					If FileExists($TargetDrive & "\images\") Then
					$msg = MsgBox(48 + 3, "Folder IMAGES exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF _
					& "CANCEL to return to the main menu")
						If $msg = 6 Then DirMove($TargetDrive & "\images", $TargetDrive & "\images.BKP")
						If $msg = 7 Then DirRemove ($TargetDrive & "\images", 1)
						If $msg = 2 Then ExitLoop
					EndIf
					$SourceList[0][0] += 1
					$FileList = _FileSearch($PESource & "\images")
					_Quick_Sort($FileList, 1, $FileList[0])
					$SourceList[0][1] += $FileList[0]
					ReDim $SourceList[$SourceList[0][0] + 1][3]
					$SourceList[$SourceList[0][0]][0] = $FileList
					$sl = StringLen($PESource & "\images")
					$SourceList[$SourceList[0][0]][1] = $sl
					$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\images"
					FileCopy($_ScriptDir & "\files\grub4dos\UBCD4WIN.LST", $TargetDrive, 1)
				EndIf
				If FileExists($PESource & "\cmdc\") Then
					If FileExists($TargetDrive & "\cmdcons\") Then
					$msg = MsgBox(48 + 3, "Folder CMDCONS exists", "YES to rename it to .BKP" & @CRLF & "NO to delete it" & @CRLF _
					& "CANCEL to return to the main menu")
						If $msg = 6 Then DirMove($TargetDrive & "\cmdcons\", $TargetDrive & "\cmdcons.BKP\")
						If $msg = 7 Then DirRemove ($TargetDrive & "\cmdcons\", 1)
						If $msg = 2 Then ExitLoop
					EndIf
					$SourceList[0][0] += 1
					$FileList = _FileSearch($PESource & "\cmdc")
					_Quick_Sort($FileList, 1, $FileList[0])
					$SourceList[0][1] += $FileList[0]
					ReDim $SourceList[$SourceList[0][0] + 1][3]
					$SourceList[$SourceList[0][0]][0] = $FileList
					$sl = StringLen($PESource & "\cmdc")
					$SourceList[$SourceList[0][0]][1] = $sl
					$SourceList[$SourceList[0][0]][2] = $TargetDrive & "\cmdcons"
					If Not FileExists($TargetDrive & "\ubcd4win.lst") Then FileCopy($_ScriptDir & "\files\grub4dos\UBCD4WIN.LST", $TargetDrive, 1)
				EndIf
			EndIf ;ubcd4win
			;boot menu entries
			If FileExists($TargetDrive & "\ubcd4win.lst") Then
				$menulst = FileOpen($TargetActive & "\menu.lst", 1)
				FileWriteLine($menulst, @CRLF & "title Start UBCD4Win from partition " & $USBdrives[$USBdrives[0][1]][3])
				FileWriteLine($menulst, "configfile (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")/ubcd4win.lst")
				FileClose($menulst)
				If GUICtrlRead($AddPECheck) = $GUI_CHECKED Then
					Logging("Replacing (hd0,0) with (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")" & " in ubcd4win.lst")
					HexReplace($TargetDrive & "\ubcd4win.lst", "(hd0,0)", "(hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
				EndIf
			Else
				If FileExists($PESource & "\Setup\") Then
					$menulst = FileOpen($TargetActive & "\menu.lst", 1)
					FileWriteLine($menulst, @CRLF & "title Start WinFLPC setup from partition " & $USBdrives[$USBdrives[0][1]][3])
					FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
					FileWriteLine($menulst, "chainloader /minint/setupldr.bin")
					FileClose($menulst)
				Else
					$menulst = FileOpen($TargetActive & "\menu.lst", 1)
					FileWriteLine($menulst, @CRLF & "title Start BartPE/WinBuilder from partition " & $USBdrives[$USBdrives[0][1]][3])
					FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
					FileWriteLine($menulst, "chainloader /minint/setupldr.bin")
					FileClose($menulst)
				EndIf
			EndIf
		EndIf ;pesource
		;vista
		If $VistaSource <> "" And GUICtrlRead($AddVistaCheck) = $GUI_CHECKED Then
			Logging("Preparing Vista source")
			_GUICtrlStatusBar_SetText($hStatus,"Preparing Vista source", 2)
			$SourceList[0][0] += 1
			$FileList = _FileSearch($VistaSource)
			_Quick_Sort($FileList, 1, $FileList[0])
			$SourceList[0][1] += $FileList[0]
			ReDim $SourceList[$SourceList[0][0] + 1][3]
			$SourceList[$SourceList[0][0]][0] = $FileList
			$sl = StringLen($VistaSource)
			$SourceList[$SourceList[0][0]][1] = $sl
			$SourceList[$SourceList[0][0]][2] = $TargetDrive
			$menulst = FileOpen($TargetActive & "\menu.lst", 1)
			FileWriteLine($menulst, @CRLF & "title Start Vista Setup/PE/Recovery from partition " & $USBdrives[$USBdrives[0][1]][3])
			FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
			FileWriteLine($menulst, "chainloader /bootmgr")
			FileClose($menulst)
		EndIf ;vista 
		
		;PMagic
		If $PMagicSource <> "" And GUICtrlRead($AddPMagicCheck) = $GUI_CHECKED Then
			$PMfilename = StringTrimLeft($PMagicSource, StringInStr($PMagicSource, "\", 0, -1))
			Logging("Adding " & $PMfilename)
			_GUICtrlStatusBar_SetText($hStatus,"Adding " & $PMfilename, 2)
			Dim $FileList [2]
			$SourceList[0][0] += 1
			$FileList[0] = 1
			$FileList[1] = $PMagicSource
			$SourceList[0][1] += $FileList[0]
			ReDim $SourceList[$SourceList[0][0] + 1][3]
			$SourceList[$SourceList[0][0]][0] = $FileList
			$sl = StringLen($PMagicSource)
			$SourceList[$SourceList[0][0]][1] = $sl
			$SourceList[$SourceList[0][0]][2] = $TargetDrive
			$menulst = FileOpen($TargetActive & "\menu.lst", 1)
 			FileWriteLine($menulst, @CRLF & "title Start " & $PMfilename & " from partition " & $USBdrives[$USBdrives[0][1]][3])
			FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
			FileWriteLine($menulst, "map /" & $PMfilename & " (0xff) || map --mem /" & $PMfilename & " (0xff)")
			FileWriteLine($menulst, "map --hook" & @CRLF & "root (0xff)" & @CRLF & "configfile /grub4dos.lst || chainloader (0xff)")
			FileClose($menulst)
		EndIf ;PMagic
		;syslinux
		If GUICtrlRead($AddSysLinuxCheck) = $GUI_CHECKED Then
			Logging("Preparing SysLinux source")
			_GUICtrlStatusBar_SetText($hStatus,"Preparing SysLinux source", 2)
			If $USBdrives[$USBdrives[0][1]][7] = "NTFS" Then
				MsgBox(16, "Not supported", "Syslinux bootsector cannot be installed on a NTFS formatted partition!" & @CRLF _
				& "Will copy files, but bootsector will NOT be made.")
			Else
				$instsyslin = 1
			EndIf
			If $SysLinuxSource <> "" Then
				$SourceList[0][0] += 1
				$FileList = _FileSearch($SysLinuxSource)
				_Quick_Sort($FileList, 1, $FileList[0])
				$SourceList[0][1] += $FileList[0]
				ReDim $SourceList[$SourceList[0][0] + 1][3]
				$SourceList[$SourceList[0][0]][0] = $FileList
				$sl = StringLen($SysLinuxSource)
				$SourceList[$SourceList[0][0]][1] = $sl
				$SourceList[$SourceList[0][0]][2] = $TargetDrive
			EndIf
		EndIf ;syslinux
		;copying sources
		Logging("Copy started")
		_GUICtrlStatusBar_SetText($hStatus,"Starting copy", 2)
		$begin = TimerInit()
		For $i = 1 To $SourceList[0][0]
			$src = $SourceList[$i][0]
			$sl = $SourceList[$i][1]
			$dest = $SourceList[$i][2]
			;_ArrayDisplay($src)
			If _CopyDirWithProgress($src, $dest, $sl, $SourceList[0][1]) = -2 Then ExitLoop 2
		Next
		$dif = TimerDiff($begin) / 1000
		Logging("Copying completed." & " Took: " & $dif & " seconds")
		_GUICtrlStatusBar_SetText($hStatus,"Copy completed", 2)
	EndIf ;preparing source files and folders
		
	;taking care of unattended section and presetup.cmd/$OEM$
	;ensuring presetup is launched
	If FileExists($TargetDrive & "\$WIN_NT$.~BT\winnt.sif") And $WinSource <> "" And $sync <> 1 Then 
		$txtsetupsif = $TargetDrive & "\txtsetup.sif"
		Logging("Fixing unattended section in winnt.sif")
		_GUICtrlStatusBar_SetText($hStatus,"Fixing unattended section in winnt.sif", 2)
		If $AMD64 = 1 Then 
			$file = $TargetDrive & "\$WIN_NT$.~LS\AMD64\presetup.cmd"
		ElseIf $AMD64 = 0 Then
			$file = $TargetDrive & "\$WIN_NT$.~LS\I386\presetup.cmd"
		EndIf
		If Not FileExists($file) Then
			If $AMD64 = 1 Then 
				IniWrite($txtsetupsif, "SourceDisksFiles", "presetup.cmd", "1,,,,,,,82,0,0")
				IniWrite($txtsetupsif, "SourceDisksFiles", "setupORG.exe", "1,,,,,,,82,0,0")
			ElseIf $AMD64 = 0 Then
				IniWrite($txtsetupsif, "SourceDisksFiles", "presetup.cmd", "1,,,,,,,2,0,0")
				IniWrite($txtsetupsif, "SourceDisksFiles", "setupORG.exe", "1,,,,,,,2,0,0")
			EndIf
			FileWriteLine($file, "SET TAGFILE=\$WIN_NT$.~LS" & @CRLF & 'FOR %%h IN (U D M N O P Q R S T V W X Y) DO IF EXIST "%%h:%TAGFILE%" SET CDDRIVE=%%h:' & @CRLF)
			FileWriteLine($file, 'if "%CDDRIVE%" == "" (' & @CRLF & 'FOR %%h IN (C E F G H I J K L) DO IF EXIST "%%h:%TAGFILE%" SET CDDRIVE=%%h:' _
			& @CRLF & ")")
		EndIf
		FileSetAttrib($file, "-RSH")
		If $AMD64 = 0 Then 
			$filespath = $TargetDrive & "\$WIN_NT$.~LS\I386\"
		ElseIf $AMD64 = 1 Then 
			$filespath = $TargetDrive & "\$WIN_NT$.~LS\AMD64\"
		EndIf
		$presetup = FileRead($file)
		$presetup = StringReplace($presetup, "EXIT", "")
		$presetup &= @CRLF & "REM ===========Added by WinSetupFromUSB============" & @CRLF
		If Not FileExists($filespath & "setupORG.exe") Then
			Logging("setupORG.exe not found, replacing the original file")
			RunWait("expand " & $filespath & "setup.ex_ " & $filespath & "setupORG.exe", "", @SW_HIDE)			
			If Not FileCopy($_ScriptDir & "\files\winsetup\setup.ex_", $filespath, 1) Then
				FileSetAttrib($filespath & "setup.ex_", "-RSH")
				If Not FileCopy($_ScriptDir & "\files\winsetup\setup.ex_", $filespath, 1) Then
					FileDelete($filespath & "setup.ex_")
					If Not FileCopy($_ScriptDir & "\files\winsetup\setup.ex_", $filespath, 1) Then
						MsgBox(48, "Fatal error", "Could not replace original Setup.exe, this is a fatal error." _
						& "Will have to abort, please report at msfn.org forum")
						Logging("Could not replace original Setup.exe, aborting...")
						Quit()
					EndIf
				EndIf
			EndIf
		EndIf
		$DriversPath = IniRead($TargetDrive & "\$WIN_NT$.~BT\winnt.sif", "Unattended", "OemPnPDriversPath", "")
		If Not @error And $DriversPath <> "" Then
			Logging("Adding spdrvscn32.exe to presetup.cmd")
			$DriversPath = StringReplace($DriversPath, '"', '')
			$DriversPath = "%systemdrive%\" & $DriversPath
			$DriversPath = '"' & StringReplace($DriversPath, ";", ";%systemdrive%\") & '"'
			If $AMD64 = 0 Then 
				FileCopy($_ScriptDir & "\files\winsetup\spdrvscn32.exe", $TargetDrive & "\$WIN_NT$.~LS\I386\", 1)
				$presetup &= "%CDDRIVE%\$WIN_NT$.~LS\I386\spdrvscn32.exe /d " & $DriversPath & " /s /q /i" & @CRLF
			ElseIf $AMD64 = 1 Then 
				FileCopy($_ScriptDir & "\files\winsetup\spdrvscn64.exe", $TargetDrive & "\$WIN_NT$.~LS\AMD64\", 1)
				$presetup &= "%CDDRIVE%\$WIN_NT$.~LS\AMD64\spdrvscn64.exe /d " & $DriversPath & " /s /q /i" & @CRLF
			EndIf
		EndIf
		$presetup &= "IF EXIST %systemroot%\system32\setupold.exe DEL /F %systemroot%\system32\setupold.exe" & @CRLF
		$OEMPreinstall = IniRead($TargetDrive & "\$WIN_NT$.~BT\winnt.sif", "Unattended", "OemPreinstall", "")
		If Not @error Then
			If $OEMPreinstall = "1" Or $OEMPreinstall = '"1"' Or $OEMPreinstall = "yes" Or $OEMPreinstall = '"yes"' Then
				Logging("OEMPreinstall found, editing presetup.cmd")
				$presetup &= "IF EXIST %CDDRIVE%\$WIN_NT$.~LS\$OEM$\$1\nul xcopy %CDDRIVE%\$WIN_NT$.~LS\$OEM$\$1\*.* %systemdrive%\ /i /k /e /r /y /h" & @CRLF
				$presetup &= "IF EXIST %CDDRIVE%\$WIN_NT$.~LS\$OEM$\$$\nul xcopy %CDDRIVE%\$WIN_NT$.~LS\$OEM$\$$\*.* %systemroot%\ /i /k /e /r /y /h" & @CRLF
				$presetup &= 'IF EXIST %CDDRIVE%\$WIN_NT$.~LS\$OEM$\$Progs\nul xcopy %CDDRIVE%\$WIN_NT$.~LS\$OEM$\$Progs\*.* "%programfiles%\" /i /k /e /r /y /h' & @CRLF
			EndIf
		EndIf
		$unattend = IniReadSection($TargetDrive & "\$WIN_NT$.~BT\winnt.sif", "Unattended")
		If Not @error Then
			$unatout = @CRLF & "[Unattended]" & @CRLF
			For $i = 1 To $unattend[0][0]
				$unatout &= $unattend[$i][0] & "=" & $unattend[$i][1] & @CRLF
			Next
			IniDelete($TargetDrive & "\$WIN_NT$.~BT\winnt.sif", "Unattended")
			IniWrite($txtsetupsif, "SourceDisksFiles", "tempunat.inf", "1,,,,,,,2,0,0")
			;$presetup &= "type %systemroot%\system32\tempunat.inf >> %systemroot%\system32\$winnt$.inf" & @CRLF
			If $AMD64 = 1 Then
				FileWrite($TargetDrive & "\$WIN_NT$.~LS\AMD64\tempunat.inf", $unatout)
			Else
				FileWrite($TargetDrive & "\$WIN_NT$.~LS\I386\tempunat.inf", $unatout)
			EndIf
		EndIf
		;FileCopy($_ScriptDir & "\files\winsetup\fedit.exe", $TargetDrive & "\$WIN_NT$.~LS\I386\", 1)
		;$presetup &= "IF EXIST %systemroot%\system32\$WINNT$.PNF DEL /F %systemroot%\system32\$WINNT$.PNF" & @CRLF
		;$presetup &= "attrib -r -s -h %SystemRoot%\system32\$winnt$.inf" & @CRLF
		;$presetup &= "%CDDRIVE%\$WIN_NT$.~LS\I386\fedit.exe -f %systemroot%\system32\$winnt$.inf -rem -l:o MsDosInitiated -s Data" & @CRLF
		;$presetup &= '%CDDRIVE%\$WIN_NT$.~LS\I386\fedit.exe -f %systemroot%\system32\$winnt$.inf -add -create -l "MsDosInitiated = 0" -s Data' & @CRLF
		$presetup &= "IF NOT EXIST c:\BOOT.INI copy %CDDRIVE%\BOOT.INI c:\" & @CRLF
		$presetup &= "IF NOT EXIST c:\NTLDR copy %CDDRIVE%\NTLDR c:\" & @CRLF
		$presetup &= "IF NOT EXIST c:\NTDETECT.COM copy %CDDRIVE%\NTDETECT.COM c:\" & @CRLF
		If $AMD64 = 0 Then 
			$presetup &= "CALL %systemroot%\system32\binifix5.cmd C: /norepair /msdosinit0" & @CRLF
		ElseIf $AMD64 = 1 Then 
			$presetup &= '%CDDRIVE%\$WIN_NT$.~LS\AMD64\start64.exe "%systemroot%\system32\cmd.exe" "/c %systemroot%\syswow64\binifix5.cmd C: /norepair /msdosinit0"' & @CRLF
		EndIf
		$presetup &= "REM ====================END=======================" & @CRLF
		$presetup &= "EXIT" & @CRLF
		$file = FileOpen($file, 10)
		FileWrite($file, $presetup)
		FileClose($file)
	EndIf
	If $sync = 1 Then
		If $AMD64 = 0 Then 
			$filespath = $TargetDrive & "\$WIN_NT$.~LS\I386\"
		ElseIf $AMD64 = 1 Then 
			$filespath = $TargetDrive & "\$WIN_NT$.~LS\AMD64\"
		EndIf
		If Not FileCopy($_ScriptDir & "\files\winsetup\setup.ex_", $filespath, 1) Then
			FileSetAttrib($filespath & "setup.ex_", "-RSH")
			If Not FileCopy($_ScriptDir & "\files\winsetup\setup.ex_", $filespath, 1) Then
				FileDelete($filespath & "setup.ex_")
				If Not FileCopy($_ScriptDir & "\files\winsetup\setup.ex_", $filespath, 1) Then
					MsgBox(48, "Fatal error", "Could not replace original Setup.exe, this is a fatal error." _
					& "Will have to abort, please report at msfn.org forum")
					Logging("Could not replace original Setup.exe, aborting...")
					Quit()
				EndIf
			EndIf
		EndIf
	EndIf
	;hexedit \minint\setupldr.bin if PE and WinSetup exist and winnt.sif
	If FileExists($TargetDrive & "\txtsetup.sif") And FileExists($TargetDrive & "\minint\") And GUICtrlRead($BootOnlyCheck) = $GUI_UNCHECKED _
		And FileExists($TargetDrive & "\minint\setupldr.bin.bak") = 0 Then
		Logging("Patching \minint\setupldr.bin")
		_GUICtrlStatusBar_SetText($hStatus,"Patching minint\setupldr.bin", 2)
		HexReplace($TargetDrive & "\minint\setupldr.bin", "txtsetup.sif", "notsetup.sif", 1, 16)
		Logging("Fixing checksum check in \minint\setupldr.bin")
		HexReplace($TargetDrive & "\minint\setupldr.bin", "46DA7403E908", "46DAEB1AE908", 1, 16, 1)
	EndIf
	If FileExists($TargetDrive & "\minint\") And GUICtrlRead($AddPECheck) = $GUI_CHECKED Then
		Logging("Fixing \minint\winnt.sif")
		_GUICtrlStatusBar_SetText($hStatus,"Fixing minint\winnt.sif", 2)
		$ini = $TargetDrive & "\minint\WINNT.SIF"
		$data = 'msdosinitiated="1"' & @LF & 'floppyless="1"' & @LF & 'AutoPartition="0"' & @LF & 'UseSignatures="no"' & @LF _
		& @LF & 'winntupgrade="no"' & @LF & 'win9xupgrade="no"' & @LF
		IniWriteSection($ini, "data", $data)
		If Not FileExists($TargetDrive & "\ntdetect.com") Then FileCopy($TargetDrive & "\minint\ntdetect.com", $TargetDrive)
	EndIf
	If FileExists($TargetDrive & "\cmdcons\") And GUICtrlRead($AddPECheck) = $GUI_CHECKED Then
		Logging("Fixing \cmdcons\winnt.sif")
		_GUICtrlStatusBar_SetText($hStatus,"Fixing cmdcons\winnt.sif", 2)
		$ini = $TargetDrive & "\cmdcons\WINNT.SIF"
		$data = 'msdosinitiated="1"' & @LF & 'floppyless="1"' & @LF & 'AutoPartition="0"' & @LF & 'UseSignatures="no"' & @LF & 'InstallDir="\WINDOWS"' _
		& @LF & 'winntupgrade="no"' & @LF & 'win9xupgrade="no"' & @LF & 'EulaComplete="1"' & @LF
		IniWriteSection($ini, "data", $data)
		If Not FileExists($TargetDrive & "\ntdetect.com") Then FileCopy($TargetDrive & "\minint\ntdetect.com", $TargetDrive)
	EndIf
	If $instsyslin = 1 Then
		InstallSysLinux()
	EndIf
	If FileExists($TargetDrive & "\boot.ini") Then
		Logging("Removing duplicate entries in boot.ini")
		_GUICtrlStatusBar_SetText($hStatus,"Removing duplicate entries in boot.ini", 2)
		$file = $TargetDrive & "\boot.ini"
		_FileReadToArray($file, $aArray)
		If Not @error Then 
			$aArray_new = _ArrayUnique($aArray,1,0)
			_ArrayDelete($aArray_new, 0)
			_ArrayDelete($aArray_new, 0)
			;_ArrayDisplay($aArray_new)
			$file = FileOpen($TargetDrive & "\boot.ini", 2)
			_FileWriteFromArray($file, $aArray_new)
			FileClose($file)
		EndIf
	EndIf

	_GUICtrlStatusBar_SetText($hStatus,"Flushing data to disks", 2)
	RunWait(@ComSpec & " /c sync.exe " & StringLeft($TargetDrive, 1) & " " & StringLeft($TargetActive, 1), $_ScriptDir & "\files\tools\", @SW_HIDE)
	If GUICtrlRead($qemu) = $GUI_CHECKED And $TargetDrive <> "" Then 
		Logging("Launching QEMU")
		_GUICtrlStatusBar_SetText($hStatus,"Launching QEMU...", 2)
		Sleep(1500)
		RunWait('"' & $_ScriptDir & '\files\qemu\qemu-system-x86_64.exe' & '"' & ' -L ' & '"' & $_ScriptDir & '\files\qemu' _
		& '"' & ' -boot c -m 256 -hda //./PhysicalDrive' & $USBdrives[$USBdrives[0][1]][2],"",@SW_HIDE)
		Sleep(1000)
	EndIf
	_GUICtrlStatusBar_SetText($hStatus,"Done.", 2)
	If $WinSource <> "" And $sync <> 1 Then
		MsgBox(48, "This is important!", "Keep the USB disk plugged in AND start from USB 2 times- Text mode and GUI mode parts." & @CRLF _
		& "When the GUI mode (the graphical part) is completed you should be safe to start from internal disk.")
	Else
		MsgBox(0,"Done", "Done")
	EndIf
	ExitLoop
WEnd
	GUICtrlSetData($Go, "GO")
	DisableMenus(0)
	$WinSource = ""
	$TempWinSource = ""
	GUICtrlSetData($Source, "")
	GUICtrlSetState($BootINIAddCheck, $GUI_UNCHECKED)
	GUICtrlSetState($AddPECheck, $GUI_UNCHECKED)
	GUICtrlSetState($AddVistaCheck, $GUI_UNCHECKED)
	GUICtrlSetState($AddPMagicCheck, $GUI_UNCHECKED)
	GUICtrlSetState($AddSysLinuxCheck, $GUI_UNCHECKED)
	GUICtrlSetState($qemu, $GUI_UNCHECKED)
	EnableInputBox()
	GUICtrlSetData($ProgressAll, 0)
	PopulateUSBComboBox()
EndFunc ;==>Main()
;===================================================================================================
Func PopulateUSBComboBox()
	Local $i, $cs = 0
	If _GUICtrlComboBox_GetCurSel($ComboBoxTarget) = -1 Then 
		_GUICtrlComboBox_ResetContent($ComboBoxTarget)
	Else 
		$cs = _GUICtrlComboBox_GetCurSel($ComboBoxTarget)
		_GUICtrlComboBox_ResetContent($ComboBoxTarget)
	EndIf
	Logging("Getting USB drives information")
	_GUICtrlStatusBar_SetText($hStatus,"Getting USB drives information", 2)
	$USBdrives = _GetUSBDrivesInfo()
	;array is in format--> DriveLetter | Name | Disk# | Part# | TotalSpace | FreeSpace | DriveType | FileSystem | Bootable(-1) or Not ( )
	For $i = 1 To $USBdrives[0][0]
		GUICtrlSetData($ComboBoxTarget,$USBdrives[$i][0] & "\ " & $USBdrives[$i][1] & _
		"(" & $USBdrives[$i][4] & "MB Total) " & "(" & $USBdrives[$i][7] & ") " & "(" & $USBdrives[$i][5] & "MB Free)")
	Next
	_GUICtrlComboBox_SetCurSel($ComboBoxTarget, $cs) ;debug
	;_ArrayDisplay ($USBdrives)
	If $USBdrives[0][0] > 0 Then
		GetComboUSBSelection()
	Else
		_GUICtrlComboBox_ResetContent($ComboBoxTarget)	
		GUICtrlSetData($ComboBoxTarget,"No USB Disks detected or not properly formatted","No USB Disks detected or not properly formatted")
		Logging ("No USB Disks detected or not properly formatted")
	EndIf
	CheckSize()
	CheckGo()
EndFunc ;==>_PopulateUSBComboBox()

;===================================================================================================
Func _GetUSBDrivesInfo()
    Local $USBDlettersInfo[1][9], $NrOfFoundUSB = 0, $dp, $HasBootPart
    Local $strComputer = ".", $objDrive, $strDeviceID, $colPartitions, $objPartition, $colLogicalDisks, $objLogicalDisk
    Local $objWMIService = ObjGet("winmgmts:\\" & $strComputer & "\root\cimv2")
	If Not IsObj($objWMIService) Then
		Logging("WMI appears to be broken")
		$msg = MsgBox(4+48, "Warning !", "WMI (Windows Management Instrumentation) seems to be not working. It's needed to obtain USB disk properties." _
		& @CRLF & "Press YES to visit a web page, describing how to repair it, or NO to exit the program")
		If $msg = 6 Then 
			Run(@ComSpec & " /c " & 'start http://windowsxp.mvps.org/repairwmi.htm', "", @SW_HIDE)
			Logging("WMI repair web page opened, closing program")
			Quit()
		Else
			Logging("WMI repair web page refused, closing program")
			Quit()
		EndIf
	EndIf
    Local $colDiskDrives = $objWMIService.ExecQuery("Select * from Win32_DiskDrive Where (InterfaceType like " & chr(34) & "%USB%" & chr(34) & ")")
    For $objDrive In $colDiskDrives
		$HasBootPart = 0
        Logging( "Found USB Physical Disk: " & $objDrive.Caption & " -- " & $objDrive.DeviceID)
        $strDeviceID = StringReplace($objDrive.DeviceID, "\", "\\")
        Local $colPartitions = $objWMIService.ExecQuery("ASSOCIATORS OF {Win32_DiskDrive.DeviceID=""" & $strDeviceID & """}" _
		& "WHERE AssocClass = Win32_DiskDriveToDiskPartition")
		;check if this disk has bootable partitions
		For $objPartition In $colPartitions
			If $objPartition.Bootable = -1 Then
				$HasBootPart = 1
				ExitLoop
			EndIf
		Next
		If $HasBootPart = 1 Then
			For $objPartition In $colPartitions
				Logging( "Found USB Disk Partition: " & $objPartition.DeviceID)
				$colLogicalDisks = $objWMIService.ExecQuery("ASSOCIATORS OF {Win32_DiskPartition.DeviceID=""" & $objPartition.DeviceID & """}" _
				& "WHERE  AssocClass = Win32_LogicalDiskToPartition" )
				For $objLogicalDisk In $colLogicalDisks
					Logging( "Found USB Logical Disk: " & $objLogicalDisk.DeviceID & "  File system: " & $objLogicalDisk.FileSystem _
					& " Bootable: " & $objPartition.Bootable)
					$NrOfFoundUSB += 1
					$USBDlettersInfo[0][0] = $NrOfFoundUSB
					ReDim $USBDlettersInfo[$NrOfFoundUSB + 1][9]
					$USBDlettersInfo[$NrOfFoundUSB][0] = $objLogicalDisk.DeviceID
					$USBDlettersInfo[$NrOfFoundUSB][1] = StringReplace($objDrive.Caption, "USB device", "")
					$dp = StringSplit($objPartition.DeviceID, ",")
					$USBDlettersInfo[$NrOfFoundUSB][2] = StringRegExpReplace($dp[1], "[^0-9]", "")
					$USBDlettersInfo[$NrOfFoundUSB][3] = StringRegExpReplace($dp[2], "[^0-9]", "")
					$USBDlettersInfo[$NrOfFoundUSB][4] = Round(DriveSpaceTotal($objLogicalDisk.DeviceID), 0)
					$USBDlettersInfo[$NrOfFoundUSB][5] = Round(DriveSpaceFree($objLogicalDisk.DeviceID), 0)
					$USBDlettersInfo[$NrOfFoundUSB][6] = DriveGetType($objLogicalDisk.DeviceID)
					$USBDlettersInfo[$NrOfFoundUSB][7] = $objLogicalDisk.FileSystem
					;$USBDlettersInfo[$NrOfFoundUSB][8] = $objPartition.BootPartition
					$USBDlettersInfo[$NrOfFoundUSB][8] = $objPartition.Bootable
					;array is in format--> DriveLetter | Name | Disk# | Part# | TotalSpace | FreeSpace | DriveType | FileSystem | Bootable(-1) or Not (0)
				Next
			Next
		EndIf		
	Next

Return $USBDlettersInfo
EndFunc ;==>__GetUSBDrivesInfo()

;===================================================================================================
Func GetComboUSBSelection()
	Local $i
	$LastGroupUsed = "UsbDrive"
	$curSelectTarget = _GUICtrlComboBox_GetCurSel($ComboBoxTarget) + 1
	;_ArrayDisplay ($USBdrives)
	If $USBdrives[$curSelectTarget][6] = "Fixed" Then
		GUICtrlSetState($FixedRadio, $GUI_CHECKED)
	ElseIf $USBdrives[$curSelectTarget][6] = "Removable" Then 
		GUICtrlSetState($RemovableRadio, $GUI_CHECKED)
	Else 
		If $USBdrives[0][0] > 0 Then 
			If GUICtrlRead($ComboBoxTarget) <> "" Then
				MsgBox(48, "Disk not properly formated", "Target disk doesn't seem to be FIXED or REMOVABLE, or it is not properly formated." _
				& @CRLF & "Please select a valid target or insert another USB disk and click REFRESH button")
				Return
			Else
				MsgBox(48, "Disk not properly formated", "USB disk doesn't seem to be properly formated or doesn't have an active partition." _
				& @CRLF & "Please select a valid target or insert another USB disk and click REFRESH button" )
				Return
			EndIf
		EndIf	
	EndIf
	If $USBdrives[$curSelectTarget][2] > 19 Then 
		MsgBox(48, "Too many disks", "You seem to have too many hard disks, or you have a card reader connected." _
		& @CRLF & "Cannot yet install Grub4Dos bootsector if hard disk number > 19" & @CRLF _
		& "If you have a card reader please disconnect or disable it and click on REFRESH button")
		Return
	EndIf
	If $USBdrives[$curSelectTarget][4] > 2000 And $USBdrives[$curSelectTarget][7] = "FAT" Then 
		MsgBox(48, "Warning!","You should not be using FAT16 on partitions > 2GB !" & @CRLF _
		& "Using NTFS improves A LOT file copy speed during Text mode part of Windows Setup!" & @CRLF _
		& "To format in NTFS use HP USB format tool.")
		$NTFSWarning = 1
	Else
		If $USBdrives[$curSelectTarget][7] <> "NTFS" And $NTFSWarning = 0 Then
			MsgBox(48, "Advice!","Using NTFS improves A LOT file copy speed during Text mode part of Windows Setup!" & @CRLF _
			& "To format in NTFS use HP USB format tool.")
			$NTFSWarning = 1
		EndIf
	EndIf
	$TargetDrive=$USBdrives[$curSelectTarget][0]
	;ConsoleWrite($TargetDrive & @CRLF)
	$USBdrives[0][1]= $curSelectTarget
	$TargetSpaceAvail = $USBdrives[$curSelectTarget][5]
	If $USBdrives[0][0] > 0 Then 
		For $i =1 To $USBdrives[0][0]
			If $USBdrives[$i][2] = $USBdrives[$curSelectTarget][2] Then
				If $USBdrives[$i][8] = -1 Then 
					$USBdrives[0][2] = $USBdrives[$i][3]
					$USBdrives[0][3] = $USBdrives[$i][0]
					$USBdrives[0][4] = $i
				EndIf
			EndIf
		Next
		If $USBdrives[0][4] = "" Then
			MsgBox(48, "Could not find active partition on the selected disk!", "Please insert USB disk with an active partition and click Refresh button.", 10)
		EndIf
	EndIf
	$TargetActive = $USBdrives[0][3]
	Logging ("Target drive selected- " & $TargetDrive)
	Logging ("Drive letter of the active partition in selected disk- " & $TargetActive)
	Logging ("Total target size avialable- " & $TargetSpaceAvail & " MB")
	_GUICtrlStatusBar_SetText($hStatus, Round($TargetSpaceAvail) & "MB", 1)
;	If $USBdrives[0][0] > 0 Then
;		If FileExists($PMagicSource & "\LIVE\") And $USBdrives[$USBdrives[0][1]][7] = "NTFS" Then 
;			$Msg=MsgBox(48,"Error!", "This version of PMagic won't work from NTFS partition!")
;			GUICtrlSetState($AddPMagicCheck, $GUI_UNCHECKED)
;			EnableInputBox()				
;		EndIf
;	EndIf
	;_ArrayDisplay ($USBdrives)
	;$USBdrives is in format--> DriveLetter | Name | Disk# | Part# | TotalSpace | FreeSpace | DriveType | FileSystem | Bootable(-1) or Not (0)
	;$USBdrives[0][0]- number of found partitions, $USBdrives[0][1]- currently selected number in this array; $USBdrives[0][2]- number of the active partition of this drive
	;$USBdrives[0][3]- the letter of the active partition, $USBdrives[0][4]- the number in array with the active partition for the selected disk
EndFunc ;==>_GetComboUSBSelection()
;===================================================================================================
Func GetSource() ; Get Windows setup source folder
	Local $Msg, $CheckFile, $TempWinSource1="", $UserExec
	$LastGroupUsed = "WinSource"
	$CheckFile=""
	While 1
		$TempWinSource = FileSelectFolder("Select Windows source, where folder I386 can be found","")
		If @error = 1 Then 
			$TempWinSource = $WinSource
			ExitLoop ;exit if cancel is pressed
		EndIf
		If StringLen($TempWinSource) = 3 Then $TempWinSource = StringLeft($TempWinSource, 2)
		If FileExists($TempWinSource & "\AMD64\dosnet.inf") Then
			If Not FileExists($TempWinSource&"\AMD64\winnt32.exe") Then
				$Msg = MsgBox(48+5,"WINNT32.EXE could not be found",@CRLF & "'WINNT32.EXE' could not be found!" _ 
				& @CRLF & "If you used Nlite to slim down source, the option 'MANUAL SETUP and UPGRADE'" _
				& "in 'Operating System Options' must NOT be used!" _
				& @CRLF & "RETRY to select a valid source or CANCEL to return to the main menu")
				If $Msg = 4 Then 
					ContinueLoop
				Else 
					ExitLoop
				EndIf
			Else
				If CheckSize() = 1 Then
					$AMD64 = 1
					$WinSource = $TempWinSource
					$TempWinSource1 = $TempWinSource & "\AMD64"
					GUICtrlSetData($Source, $WinSource)
					ExitLoop
				Else
					$TempWinSource = $WinSource
					$PrevWinSource = $WinSource
					ExitLoop
				EndIf
			EndIf
		ElseIf FileExists($TempWinSource&"\I386\dosnet.inf") Then 
			If Not FileExists($TempWinSource&"\I386\winnt32.exe") Then
				$Msg=MsgBox(48+5,"WINNT32.EXE could not be found", "WINNT32.EXE could not be found!" _ 
				& @CRLF & "If you used Nlite to slim down source the option 'MANUAL SETUP and UPGRADE'" _
				& "in 'Operating System Options' must NOT be used !" _
				& @CRLF & "RETRY to select a valid source or CANCEL to return to the main menu")
				If $Msg=4 Then 
					ContinueLoop
				Else 
					ExitLoop
				EndIf
			Else
				If CheckSize() = 1 Then
					$AMD64 = 0
					$WinSource = $TempWinSource
					$TempWinSource1 = $TempWinSource & "\I386"
					GUICtrlSetData($Source, $WinSource)
					$PrevWinSource = $WinSource
					ExitLoop
				Else
					$TempWinSource = $WinSource
					ExitLoop
				EndIf 
			EndIf		
		Else 
			$Msg=MsgBox(48+5,"Source is not valid", "This doesn't seem to be a valid source, could not find DOSNET.INF" _
			& @CRLF & @CRLF & "RETRY to select a valid source or CANCEL to return to the main menu")
			If $Msg=4 Then
				ContinueLoop
			Else
				ExitLoop 
			EndIf
		EndIf
		ExitLoop
	Wend
	If $TempWinSource1 <> "" Then
		$vers = IniRead($TempWinSource1&"\txtsetup.sif", "Strings", "productname", "NotFound")
		$sp = StringReplace(IniRead($TempWinSource1&"\txtsetup.sif", "Strings", "spcdname", "NotFound"), "CD-ROM", "")
		$sp = StringReplace($sp, "CD", "")
		If StringInStr($vers, "XP") Or StringInStr($vers, "2003") Then GUICtrlSetData($WinTarget,"\WINDOWS")
		
	;check for Windows 2000
		If $vers = "NotFound" Then
			$vers = StringReplace(IniRead($TempWinSource1&"\txtsetup.sif", "Strings", "wks_id", "NotFound"), "CD", "")
			$sp = StringReplace(IniRead($TempWinSource1&"\txtsetup.sif", "Strings", "spcd", "NotFound"), "CD", "")
			;update default BOOT.INI entry for Win 2000
			If StringInStr($vers, "2000") Then 
				GUICtrlSetData($WinTarget,"\WINNT")
				GUICtrlSetData($WinTargetAdd,"\WINNT")
			EndIf
		EndIF
	EndIf
	Logging("Windows source selected- " & $WinSource)
	Logging("Source version- " & $vers)
	Logging("Service Pack- " & $sp)
	Logging("AMD64 flag- " & $AMD64)
EndFunc ;==>_GetSource()

;===================================================================================================
Func RMPrepUSB() ; Format using RMPrepUSB
	Logging("RMPrepUSB launched")
	_GUICtrlStatusBar_SetText($hStatus,"Waiting for RMPrepUSB to close", 2)
	RunWait($_ScriptDir & "\files\tools\RMPrepUSB.exe",$_ScriptDir & "\files\tools\")
	Logging("RMPrepUSB closed")
	_GUICtrlStatusBar_SetText($hStatus,"Sleeping for 5 seconds before refreshing USB information", 2)
	Sleep(5000)
	PopulateUSBComboBox()
EndFunc

;===================================================================================================
Func EnableInputBox()
	Local $TempId
	;MsgBox (1, @GUI_CtrlId, @GUI_CtrlId)
	$TempId = @GUI_CtrlId
	If $TempId = 19 Then $LastGroupUsed = "PE"
	If $TempId = 22 Then $LastGroupUsed = "Vista"
	If $TempId = 25 Then $LastGroupUsed = "PMagic"
	If $TempId = 28 Then $LastGroupUsed = "SysLinux"	
	If $TempId = 53 Then $LastGroupUsed = "BootOnly"
		If GUICtrlRead($AddPECheck)=$GUI_CHECKED Then
			GUICtrlSetState($AddPESource, $GUI_ENABLE)
			GUICtrlSetState($AddPEBrowse, $GUI_ENABLE)
		Else
			GUICtrlSetState($AddPESource, $GUI_DISABLE)
			GUICtrlSetState($AddPEBrowse, $GUI_DISABLE)
			$PESize=0
		EndIf
	
		If GUICtrlRead($AddVistaCheck)=$GUI_CHECKED Then
			GUICtrlSetState($AddVistaSource, $GUI_ENABLE)
			GUICtrlSetState($AddVistaBrowse, $GUI_ENABLE)
			
		Else
			GUICtrlSetState($AddVistaSource, $GUI_DISABLE)
			GUICtrlSetState($AddVistaBrowse, $GUI_DISABLE)
			$VistaSize=0
		EndIf
	
		If GUICtrlRead($AddPMagicCheck)=$GUI_CHECKED Then
			GUICtrlSetState($AddPMagicSource, $GUI_ENABLE)
			GUICtrlSetState($AddPMagicBrowse, $GUI_ENABLE)
		Else
			GUICtrlSetState($AddPMagicSource, $GUI_DISABLE)
			GUICtrlSetState($AddPMagicBrowse, $GUI_DISABLE)
			$PMagicSize = 0
		EndIf
	
	
		If GUICtrlRead($AddSysLinuxCheck)=$GUI_CHECKED Then
			If $SysLinuxSource <> "" Then 
				GUICtrlSetData($AddSysLinuxSource, $SysLinuxSource)
			Else
				GUICtrlSetData($AddSysLinuxSource, $_ScriptDir & "\syslinux.exe")
			EndIf
			GUICtrlSetState($AddSysLinuxSource, $GUI_ENABLE)
			GUICtrlSetState($AddSysLinuxBrowse, $GUI_ENABLE)
		Else
			GUICtrlSetState($AddSysLinuxSource, $GUI_DISABLE)
			GUICtrlSetState($AddSysLinuxBrowse, $GUI_DISABLE)
			$SysLinuxSize = 0
		EndIf
	
		If GUICtrlRead($BootINIAddCheck)=$GUI_CHECKED Then
			GUICtrlSetState($WinTargetAdd, $GUI_ENABLE)
			GUICtrlSetState($TargetDiskAdd, $GUI_ENABLE)
			GUICtrlSetState($TargetPartitionAdd, $GUI_ENABLE)
		Else
			GUICtrlSetState($WinTargetAdd, $GUI_DISABLE)
			GUICtrlSetState($TargetDiskAdd, $GUI_DISABLE)
			GUICtrlSetState($TargetPartitionAdd, $GUI_DISABLE)
		EndIf
	CheckSize()	
				
EndFunc	;EnableInputBox()
;====================================================================================================
Func BootOnly()
	$LastGroupUsed = "BootOnly"
	If GUICtrlRead($BootOnlyCheck)=$GUI_CHECKED Then
			GUICtrlSetState($WinTarget, $GUI_DISABLE)
			GUICtrlSetState($WinTargetDisk, $GUI_DISABLE)
			GUICtrlSetState($WinTargetPartition, $GUI_DISABLE)
			GUICtrlSetState($BootINIAddCheck, $GUI_DISABLE)
			GUICtrlSetState($AddPECheck, $GUI_DISABLE)
			GUICtrlSetState($AddVistaCheck, $GUI_DISABLE)
			GUICtrlSetState($AddPMagicCheck, $GUI_DISABLE)
			GUICtrlSetState($AddSysLinuxCheck, $GUI_DISABLE)			
			GUICtrlSetState($WinTargetAdd, $GUI_DISABLE)
			GUICtrlSetState($TargetDiskAdd, $GUI_DISABLE)
			GUICtrlSetState($TargetPartitionAdd, $GUI_DISABLE)
			GUICtrlSetState($TargetPartitionAdd, $GUI_DISABLE)
			GUICtrlSetState($AddSysLinuxSource, $GUI_DISABLE)
			GUICtrlSetState($AddSysLinuxBrowse, $GUI_DISABLE)
			GUICtrlSetState($AddPMagicSource, $GUI_DISABLE)
			GUICtrlSetState($AddPMagicBrowse, $GUI_DISABLE)
			GUICtrlSetState($AddVistaSource, $GUI_DISABLE)
			GUICtrlSetState($AddVistaBrowse, $GUI_DISABLE)
			GUICtrlSetState($AddPESource, $GUI_DISABLE)
			GUICtrlSetState($AddPEBrowse, $GUI_DISABLE)
			CheckSize()
		Else
			GUICtrlSetState($WinTarget, $GUI_ENABLE)
			GUICtrlSetState($WinTargetDisk, $GUI_ENABLE)
			GUICtrlSetState($WinTargetPartition, $GUI_ENABLE)
			GUICtrlSetState($BootINIAddCheck, $GUI_ENABLE)
			GUICtrlSetState($AddPECheck, $GUI_ENABLE)
			GUICtrlSetState($AddVistaCheck, $GUI_ENABLE)
			GUICtrlSetState($AddPMagicCheck, $GUI_ENABLE)
			GUICtrlSetState($AddSysLinuxCheck, $GUI_ENABLE)
			CheckSize()
			EnableInputBox()
	EndIf
EndFunc ;==>BootOnly()


;===================================================================================================
Func GetVistaSource() 
	
While 1
	$LastGroupUsed = "Vista"
	$TempVistaSource = FileSelectFolder("Select Vista Setup source, where folders BOOT and SOURCES can be found","")
	If @error = 1 Then ;exit if cancel is pressed and set the previous value
		$TempVistaSource = $VistaSource
		If $VistaSource = "" Then
			GUICtrlSetState($AddVistaCheck, $GUI_UNCHECKED)
			EnableInputBox()
			ExitLoop
		EndIf
		ExitLoop
	EndIf
	If StringLen($TempVistaSource) = 3 Then $TempVistaSource = StringLeft($TempVistaSource, 2)
	If FileExists($TempVistaSource & "\BOOT\") + FileExists($TempVistaSource & "\SOURCES\") < 1 Then 
		$Msg=MsgBox(48+5,"Error!", "Folder BOOT or SOURCES could not be found" _ 
		& @CRLF & "RETRY to select another source or CANCEL to return to the main menu")
		If $Msg=4 Then 
			ContinueLoop
		Else 
			GUICtrlSetState($AddVistaCheck, $GUI_UNCHECKED)
			EnableInputBox()
			ExitLoop
		EndIf
	EndIf
	If CheckSize() = 1 Then 
		$VistaSource = $TempVistaSource
		CheckGo()
		Logging("Vista source selected- " & $VistaSource)
		GUICtrlSetData($AddVistaSource, $VistaSource)
	Else
		$TempVistaSource = $VistaSource
	EndIf
	ExitLoop
WEnd
EndFunc ;==>_GetVistaSource()

;===================================================================================================
Func GetPESource() 
	Local $PEVers
	$LastGroupUsed = "PE"
	While 1
		$TempPESource = FileSelectFolder("Select BartPE folder, where folder I386 can be found","")
		If @error = 1 Then ;exit if cancel is pressed and set the previous value
			$TempPESource = $PESource
			If $PESource = "" Then
				GUICtrlSetState($AddPESource, $GUI_UNCHECKED)
				EnableInputBox()
				ExitLoop
			EndIf
			ExitLoop
		EndIf
		If StringLen($TempPESource) = 3 Then $TempPESource = StringLeft($TempPESource, 2)
		If FileExists($TempPESource & "\I386\") + FileExists($TempPESource & "\programs\") + FileExists($TempPESource & "\program files\") < 2 Then
			$Msg=MsgBox(48 + 5,"Error!", "Folder I386, Programs or Program Files could not be found" _ 
			& @CRLF & "RETRY to select another source or CANCEL to return to the main menu")
			If $Msg=4 Then 
				ContinueLoop
			Else 
				GUICtrlSetState($AddPECheck, $GUI_UNCHECKED)
				EnableInputBox()
				ExitLoop
			EndIf
		EndIf
		If CheckSize() = 1 Then 
			$PESource = $TempPESource
			CheckGo()
			Logging("PE source selected- " & $PESource)
			GUICtrlSetData($AddPESource, $PESource)
		Else
			$TempPESource = $PESource
		EndIf
		ExitLoop
	WEnd
EndFunc ;==>_GetPESource()

;===================================================================================================
;$USBdrives is in format--> DriveLetter | Name | Disk# | Part# | TotalSpace | FreeSpace | DriveType | FileSystem | Bootable(-1) or Not (0)
;$USBdrives[0][0]- number of found partitions, $USBdrives[0][1]- currently selected number in this array; $USBdrives[0][2]- the active partition of this drive
;$USBdrives[0][3]- the letter of the active partition, $USBdrives[0][4]- the number in array with the active partition for the selected disk
Func GetPMagicSource()
	$LastGroupUsed = "PMagic"
	;check for LIVE or PMagic.DAT
	While 1
		$TempPMSource = FileOpenDialog("Select pmagic-3.X.iso", "", "ISO files (*.iso)", 1+2)
		If @error = 1 Then ;exit if cancel is pressed and set the previous value
			$TempPMSource = $PMagicSource
			If $PMagicSource = "" Then
				GUICtrlSetState($AddPMagicCheck, $GUI_UNCHECKED)
				EnableInputBox()
				ExitLoop
			EndIf
			ExitLoop
		EndIf
		If CheckSize() = 1 Then 
			$PMagicSource = $TempPMSource
			CheckGo()
			Logging("PartedMagic source selected- " & $PMagicSource)
			GUICtrlSetData($AddPMagicSource, $PMagicSource)
		Else
			$TempPMSource = $PMagicSource
		EndIf
		ExitLoop
	WEnd
EndFunc ;==>_GetPMagicSource()

;===================================================================================================
Func GetSysLinuxSource() 
	$LastGroupUsed = "SysLinux"
	While 1
		$TempSysLinuxSource = FileSelectFolder("Select a folder with SysLinux based Linux distro, where folder SYSLINUX can be found" _
	& "Entire contents of selected folder will be copied", "")
		If @error = 1 Then ;exit if cancel is pressed and set the previous value
			$TempSysLinuxSource = $SysLinuxSource
			If $PMagicSource = "" Then
				GUICtrlSetState($AddSysLinuxCheck, $GUI_UNCHECKED)
				EnableInputBox()
				ExitLoop
			EndIf
			ExitLoop
		EndIf
		If StringLen($TempSysLinuxSource) = 3 Then $TempSysLinuxSource = StringLeft($TempSysLinuxSource, 2)
		If CheckSize() = 1 Then
			$SysLinuxSource = $TempSysLinuxSource
			CheckGo()
			Logging("SysLinux based Linux selected-" & $SysLinuxSource)
			GUICtrlSetData($AddSysLinuxSource, $SysLinuxSource)
		Else
			$TempSysLinuxSource = $SysLinuxSource
		EndIf
		ExitLoop
	WEnd
	If $USBdrives[$USBdrives[0][1]][7] = "NTFS" Then
		MsgBox(16, "Not supported", "Syslinux bootsector cannot be installed on a NTFS formatted partition!" & @CRLF _
		& "Will copy files, but bootsector will NOT be made.")
	EndIf
EndFunc ;==>_GetSysLinuxSource()

;===================================================================================================
Func CheckSize()
	Logging("Checking sizes...")
	;ConsoleWrite("Checking Sizes" & @CRLF)
	_GUICtrlStatusBar_SetText($hStatus,"Getting directory size", 2)
	If GUICtrlRead($AddPECheck)=$GUI_CHECKED Then 
		If $TempPESource <> "" Then
			$PESize = DirGetSize($TempPESource & "\I386")
			If FileExists($TempPESource & "\programs\") Then $PESize = $PESize  + DirGetSize($TempPESource & "\programs\")
			If FileExists($TempPESource & "\Program Files\") Then $PESize = $PESize  + DirGetSize($TempPESource & "\Program Files\")
			If FileExists($TempPESource & "\images\") Then $PESize = $PESize  + DirGetSize($TempPESource & "\images\")
			If FileExists($TempPESource & "\cmdc\") Then $PESize = $PESize  + DirGetSize($TempPESource & "\cmdc\")
			If FileExists($TempPESource & "\Setup\") Then $PESize = $PESize  + DirGetSize($TempPESource & "\Setup\")
			$PESize = Round($PESize / 1024 / 1024,1)
		EndIf
	Else
		$PESize = 0
	EndIF
	If GUICtrlRead($AddVistaCheck)=$GUI_CHECKED Then 
		If $TempVistaSource <> "" Then
			$VistaSize = DirGetSize($TempVistaSource)
			$VistaSize = Round($VistaSize / 1024 / 1024,1)
		EndIf
	Else
		$VistaSize = 0
	EndIF
	If GUICtrlRead($AddPMagicCheck)=$GUI_CHECKED Then 
		If $TempPMSource <> "" Then
			$PMagicSize = FileGetSize($TempPMSource)
			$PMagicSize = Round($PMagicSize / 1024 / 1024,1)
		EndIf
	Else
		$PMagicSize = 0
	EndIF
	If GUICtrlRead($AddSysLinuxCheck) = $GUI_CHECKED Then 
		If $TempSysLinuxSource <> "" Then
			$SysLinuxSize = DirGetSize($TempSysLinuxSource)
			$SysLinuxSize = Round($SysLinuxSize / 1024 / 1024,1)
		EndIf
	Else
		$SysLinuxSize = 0
	EndIF
	If $TempWinSource <> "" Then
		$WinSourceSize = DirGetSize($TempWinSource & "\I386")
		If FileExists($TempWinSource & "\AMD64\") Then $WinSourceSize = $WinSourceSize  + DirGetSize($TempWinSource & "\AMD64\")
		If FileExists($TempWinSource & "\OEM\") Then $WinSourceSize = $WinSourceSize  + DirGetSize($TempWinSource & "\OEM\")
		If FileExists($TempWinSource & "\$OEM$\") Then $WinSourceSize = $WinSourceSize  + DirGetSize($TempWinSource & "\$OEM$\")
		If FileExists($TempWinSource & "\CMPNENTS\") Then $WinSourceSize = $WinSourceSize  + DirGetSize($TempWinSource & "\CMPNENTS\")
		If FileExists($TempWinSource & "\PRINTERS\") Then $WinSourceSize = $WinSourceSize  + DirGetSize($TempWinSource & "\PRINTERS\")
		$WinSourceSize = Round($WinSourceSize / 1024 / 1024,1) + 12
	Else
		$WinSourceSize = 0
	EndIf
	If GUICtrlRead($BootOnlyCheck) = $GUI_UNCHECKED Then
		$TotalSourceSize = $WinSourceSize + $VistaSize + $PESize +$PMagicSize + $SysLinuxSize
	Else
		$TotalSourceSize=12
	EndIf
	
	_GUICtrlStatusBar_SetText($hStatus, Round($TotalSourceSize) & "MB", 0)
	If $TargetSpaceAvail <> 0 Then
		If $TempWinSource <> "" And $USBdrives[$USBdrives[0][1]][3] <> 0 Then
			MsgBox(48,"Not supported!", "Windows setup can be started only from the first partition!")
			Logging("Windows setup can be started only from the first partition")
			$TotalSourceSize = $TotalSourceSize - $WinSourceSize
			_GUICtrlStatusBar_SetText($hStatus, Round($TotalSourceSize) & "MB", 0)
			Return 0
		EndIF
		If $TotalSourceSize > $TargetSpaceAvail Then
			$Msg = MsgBox(48+5, "No enough space", "There is no enough space on target disk to add the current selection!" & @CRLF _
			& "Click RETRY to select another folder, or CANCEL to ignore the last selection" )
			Logging("There is no enough space on target disk to add the current selection!")
			Logging("Total source size- " & $TotalSourceSize & " MB")
			Logging("Target space available- " & $TargetSpaceAvail & " MB")
			If $LastGroupUsed = "PE" Then 
				If $Msg = 4 Then
					Logging("PE source size-" & $PESize & " MB")
					GetPESource()
				Else
					GUICtrlSetState($AddPECheck, $GUI_UNCHECKED)
					EnableInputBox()
				EndIf
			ElseIf $LastGroupUsed = "Vista" Then
				Logging("Vista source size- " & $VistaSize & " MB")
				If $Msg = 4 Then
					GetVistaSource()
				Else
					GUICtrlSetState($AddVistaCheck, $GUI_UNCHECKED)
					EnableInputBox()
				EndIf
			ElseIf $LastGroupUsed = "SysLinux" Then
				Logging("SysLinux source size- " & $SysLinuxSize & " MB")
				If $Msg = 4 Then
					GetSysLinuxSource()
				Else
					GUICtrlSetState($AddSysLinuxCheck, $GUI_UNCHECKED)
					EnableInputBox()
				EndIf
			ElseIf $LastGroupUsed = "WinSource" Then
				Logging("Windows source Size- " & $WinSourceSize & " MB")
				;ConsoleWrite ("$TempWinSource= " & $TempWinSource & @CRLF)
				;ConsoleWrite ("$WinSource= " & $WinSource & @CRLF)
				If $Msg = 4 Then
					GetSource()
				Else
					GUICtrlSetData($Source, $PrevWinSource)
					$WinSource = $PrevWinSource
					$TempWinSource = $PrevWinSource
					CheckSize()
				EndIf
			ElseIf $LastGroupUsed = "BootOnly" Then
				If $Msg = 4 Then
					GetSource()
				Else
					GUICtrlSetState($BootOnlyCheck, $GUI_CHECKED)
					BootOnly()
					EnableInputBox()
				EndIf
			EndIf
			Return 0
		Else
			CheckGo()
			Logging ("Total source size- " & $TotalSourceSize & " MB")
			Logging("Target space available- " & $TargetSpaceAvail & " MB")
			_GUICtrlStatusBar_SetText($hStatus, Round($TotalSourceSize) & "MB", 0)
			Return 1
		EndIf
	Else
		CheckGo()
		Logging ("Total source size- " & $TotalSourceSize & " MB")
		Logging("Target space available- " & $TargetSpaceAvail & " MB")
		If  $USBdrives[$USBdrives[0][1]][3] = 0 Then _GUICtrlStatusBar_SetText($hStatus, "0MB", 1)
		Return 1
	EndIf

EndFunc ;==>_CheckSize()

;===================================================================================================
Func CheckGo()
	;ConsoleWrite("$TempWinSource: " & $TempWinSource & @LF)
	;ConsoleWrite("$WinSource: " & $WinSource & @LF)
	If $TotalSourceSize > 0 And $TargetSpaceAvail >= $TotalSourceSize And $USBdrives[0][0] <> 0 Then 
		GUICtrlSetState($GO, $GUI_ENABLE)
		_GUICtrlStatusBar_SetText($hStatus,"Ready...", 2)
	Else
		GUICtrlSetState($GO, $GUI_DISABLE)
		_GUICtrlStatusBar_SetText($hStatus,"Not ready...", 2)
	EndIf
	If GUICtrlRead($BootOnlyCheck) = $GUI_CHECKED And $TempWinSource <> "" Then
		GUICtrlSetState($GO, $GUI_ENABLE)
		_GUICtrlStatusBar_SetText($hStatus,"Ready...", 2)
	ElseIf GUICtrlRead($BootOnlyCheck) = $GUI_CHECKED And $TempWinSource = "" Then
		_GUICtrlStatusBar_SetText($hStatus,"Not ready...", 2)
		GUICtrlSetState($GO, $GUI_DISABLE)
	EndIf
	If GUICtrlRead($qemu) = $GUI_CHECKED Then 
		_GUICtrlStatusBar_SetText($hStatus,"Ready...", 2)
		GUICtrlSetState($GO, $GUI_ENABLE) 
	EndIf
	If GUICtrlRead($AddSysLinuxCheck) = $GUI_CHECKED Then 
		_GUICtrlStatusBar_SetText($hStatus,"Ready...", 2)
		GUICtrlSetState($GO, $GUI_ENABLE)
	EndIf
EndFunc ;==>_CheckGo()

;===================================================================================================
Func MakeBT()
	_GUICtrlStatusBar_SetText($hStatus,"Parsing DOSNET.INF", 2)
	Local $TempList[1], $DosNet, $Path, $i=0, $j=0, $k, $h, $Section, $Subst[1][1], $strlen, $Sour, $Dest, $ini, $data, $Msg, $file
	If $AMD64 = 0 Then 
		$Path = "\I386\"
	Else
		$Path = "\AMD64\"
	EndIf
	$DosNet = $WinSource & $Path & "dosnet.inf"
	$file = FileOpen($DosNet, 0)
; Check if file opened for reading OK
	If $file = -1 Then
		MsgBox(48, "Error", "Unable to open " & $DosNet & @CRLF & "Exiting in 10 seconds...", 10)
		Exit
	EndIf
	;get contents of [FloppyFiles.(0-n)]
While 1
	$line = FileReadLine($file)
	If @error = -1 Then ExitLoop ;end of file
	$line = StringReplace($line, '"', '') ;remove "
	$line = StringReplace($line, ' ', '') ;remove spaces
	If $Line <> "" Then
		If StringLeft($line, 1) = "[" Then 
			$Section = $line
			ContinueLoop
		EndIf
		If StringLeft($line, 1) = ";" Or StringLeft($line, 1) = "#" Then ContinueLoop
		If StringLeft($Section, 14) = "[FloppyFiles.x" Then ContinueLoop
		If StringLeft($Section, 12) = "[FloppyFiles" Then
			$i = $i + 1
			$TempList[0] = $i
			ReDim $TempList [$i+1]
			$TempList[$i] = $line
		;ElseIf StringLeft($Section, 13) = "[Directories]" Then
		;	$j = $j + 1
		;	ReDim $Subst[$j + 1][2]
		;	$Subst[0][0] = $j
		;	$Subst[$j][0] = StringLeft($line, 2)
		;	$strlen = StringLen ($line)
		;	$Subst[$j][1] = StringRight($line, $strlen - 2)
		;	$Subst[$j][1] = StringRegExpReplace($Subst[$j][1], "[\h=]", "")
		;	If $Subst[$j][1] = "\" Then $Subst[$j][1] = "\I386"  ;Added for Windows 2000
		EndIf
	EndIf
Wend
	FileClose($DosNet)
	$Subst = IniReadSection($DosNet, "Directories")
	If @error Then 
		MsgBox(4096, "", "Error occurred, could not parse section Directories in DOSNET.INF." & @CRLF & "This is critical error, aborting in 5 seconds...", 5)
		Logging("ERROR!!!----Could not parse section Directories in DOSNET.INF, aborting...")
		Exit
	EndIf
		
	;_ArrayDisplay($Subst)
	;_ArrayDisplay($TempList)
	Logging("DOSNET.INF parsed, " & $TempList[0] & " files for ~BT folder")
	For $i = 1 To $TempList[0]
		For $k = 1 To $Subst[0][0]
			$Subst[$k][0] = StringReplace($Subst[$k][0], '"', '') ;remove "
			$Subst[$k][1] = StringReplace($Subst[$k][1], '"', '') ;remove "
			$Subst[$k][0] = StringReplace($Subst[$k][0], ' ', '') ;remove spaces
			$Subst[$k][1] = StringReplace($Subst[$k][1], ' ', '') ;remove spaces
			If $Subst[$k][1] = "\" And StringInStr($vers, "2000") <> 0 Then $Subst[$k][1] = "\I386"  ;Windows 2000
			$TempList[$i] = StringReplace($TempList[$i], $Subst[$k][0] & ',', $Subst[$k][1] & '\', 1) ; change d1, ... d(n) + , with the corresponding directory + \
			If @extended = 1 Then ExitLoop
			;If StringLeft($TempList[$i], 1) = " " Then $TempList[$i] = StringTrimLeft($TempList[$i], 1)
		Next
		;replace second comma with the new file name/directory ( d1,ntdll.dll,system32\ntdll.dll )
		$h = StringInStr($TempList[$i], ",")
		If $h <> 0 Then
			$Sour = $WinSource & StringLeft($TempList[$i], $h - 1)
			$Dest = $_ScriptDir & "\TEMP\$WIN_NT$.~BT\" & StringRight($WinSource & $TempList[$i], StringLen($TempList[$i])-$h)
		Else
			$Sour = $WinSource & $TempList[$i]
			$Dest = $_ScriptDir & "\TEMP\$WIN_NT$.~BT\"
		EndIf
		;nLite 1.4.5
		$Sour = StringReplace($Sour, '"', '', 0)
		$Dest = StringReplace($Dest, '"', '', 0)
		If FileCopy($Sour, $Dest, 9) Then 
			Logging($Sour & "---> " & $Dest)
		Else
			If FileCopy(StringTrimRight($Sour, 1) & "_", $Dest, 9) Then ;because of the compressed files, ending with _
				Logging(StringTrimRight($Sour, 1) & "_" & " ---> " & $Dest)
			Else
				Logging("ERROR!!!----" & $Sour & " could not be copied to " & $Dest)
			EndIf
		EndIf
	Next
	;_ArrayDisplay($TempList)
	Logging("Preparing ~BT folder completed")
	_GUICtrlStatusBar_SetText($hStatus,"Copying boot files to \TEMP", 2)
	FileCopy($WinSource & $path & "AUTOCHK.EXE", $_ScriptDir & "\TEMP\$WIN_NT$.~LS\" & $Path, 8)
	FileCopy($WinSource & $path & "AUTOFMT.EXE", $_ScriptDir & "\TEMP\$WIN_NT$.~LS\" & $Path, 8)
	FileCopy($WinSource & $path & "EULA.TXT", $_ScriptDir & "\TEMP\$WIN_NT$.~LS\" & $Path, 8)
	FileCopy($WinSource & "\I386\NTDETECT.COM", $_ScriptDir & "\TEMP\", 8)
	FileCopy($WinSource & "\I386\NTLDR", $_ScriptDir & "\TEMP\", 8)
	FileCopy($WinSource & $path & "TXTSETUP.SIF", $_ScriptDir & "\TEMP\", 8)
	FileSetAttrib($_ScriptDir & "\TEMP\TXTSETUP.SIF", "-RSH")
	FileSetAttrib($_ScriptDir & "\TEMP\$WIN_NT$.~BT\TXTSETUP.SIF", "-RSH")
	If FileExists($WinSource & $path & "bootfont.bin") Then FileCopy($WinSource & $path & "bootfont.bin", $_ScriptDir & "\TEMP\") 
	FileCopy($WinSource & $path & "WINNT.SIF", $_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", 1)
	Logging("Launching MkMigrateInf3.cmd")
	;MsgBox(0,"",$TargetDrive & " " & '"' & $_ScriptDir & 'temp\$win_nt$.~bt\migrate.inf"')
	RunWait(@ComSpec & " /c MkMigrateInf3.cmd " & $TargetDrive & " " & '"' & $_ScriptDir & '\temp\$win_nt$.~bt\migrate.inf"', $_ScriptDir & "\files\winsetup", @SW_HIDE)
	If Not FileExists($_ScriptDir & '\temp\$win_nt$.~bt\migrate.inf') Then Logging("ERROR!!!--- Could not create migrate.inf")
	FileSetAttrib($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "-RSH")
	IniWrite($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "data", "floppyless", '"1"')
	IniWrite($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "data", "msdosinitiated", '"1"')
	;IniWrite($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "data", "winntupgrade", '"no"')
	;IniWrite($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "data", "win9xupgrade", '"no"')
	;IniWrite($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "data", "EulaComplete", '"1"')
	IniWrite($_ScriptDir & "\TEMP\$WIN_NT$.~BT\WINNT.SIF", "data", "AutoPartition", '"0"')
	;boot menus
	If Not FileExists ($TargetActive & "\winsetup.lst") Then
		FileCopy($_ScriptDir & "\files\grub4dos\winsetup.lst", $TargetActive & "\winsetup.lst", 1)
	EndIf
	If Not FileExists ($TargetActive & "\windefault") Then
		FileCopy($_ScriptDir & "\files\grub4dos\default", $TargetActive & "\windefault", 1)
	EndIf
	$file = FileRead ($TargetActive & "\menu.lst")
	;MsgBox (0, "", $file)
	$menulst = FileOpen($TargetActive & "\menu.lst", 1)
	If Not StringInStr ($file, "title Windows XP/2000/2003 Setup- First and Second parts") Then
		FileWriteLine($menulst, @CRLF & "title Windows XP/2000/2003 Setup- First and Second parts")
		FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
		FileWriteLine($menulst, "configfile /winsetup.lst")
		FileWriteLine($menulst, "savedefault")
	EndIf
	FileClose($menulst)
	$menulst = FileOpen($TargetActive & "\winsetup.lst", 1)
	FileWriteLine($menulst, @CRLF & "title First part of " & $vers & " setup")
	FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
	FileWriteLine($menulst, "chainloader (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")/$WIN_NT$.~BT/SETUPLDR.BIN" & @CRLF)
	FileWriteLine($menulst, "savedefault 1" & @CRLF)
	FileClose($menulst)
EndFunc 

;===================================================================================================
Func BackUp($trg)
;$USBdrives is in format--> DriveLetter | Name | Disk# | Part# | TotalSpace | FreeSpace | DriveType | FileSystem | Bootable(-1) or Not (0)
;$USBdrives[0][0]- number of found partitions, $USBdrives[0][1]- currently selected number in this array; $USBdrives[0][2]- number of the active partition of this drive
;$USBdrives[0][3]- the letter of the active partition, $USBdrives[0][4]- the number in array with the active partition for the selected disk
	Local $trggrub, $bkp
	;_ArrayDisplay($USBdrives)
	Logging("Backing up MBR of disk #" & $USBdrives[$trg][2])
	_GUICtrlStatusBar_SetText($hStatus,"Backing up MBR of disk #" & $USBdrives[$trg][2], 2)
	$bkp = "mbrdisk" & $USBdrives[$trg][2] & "-" & $dt & ".dat"
	$trggrub = "(hd" & $USBdrives[$trg][2] & ")"
	Logging ($_ScriptDir & "\files\grub4dos\grubinst.exe -s=" & $bkp & " -t " & $trggrub)
	RunWait('"' & $_ScriptDir & "\files\grub4dos\grubinst.exe" & '" ' & "-s=" & $bkp & " -t " & $trggrub, $_ScriptDir, @SW_HIDE)
	Sleep(2000)
;	Logging(FileRead(@TempDir & "\grmbr.tmp"))
	If Not FileExists($_ScriptDir & "\" & $bkp) Then
		MsgBox(4096, "Fatal error", "grubinst.exe could not make a backup of MBR!" & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("grubinst.exe could not make a backup of MBR of disk #" & $USBdrives[$trg][2])
		Quit()
	EndIf
	Logging("Backed up MBR of disk #" & $USBdrives[$trg][2])
	FileMove($_ScriptDir & "\" & $bkp, $_ScriptDir & "\backups\", 9)
	If FileExists($_ScriptDir & "\" & $bkp) Then
		RunWait(@ComSpec & " /c move /y " & '"' & $_ScriptDir & "\" & $bkp & '" "' & $_ScriptDir & "\backups\" & $bkp & '"', $_ScriptDir, @SW_SHOW)
	EndIf
	Logging("Backing up BootSector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3])
	_GUICtrlStatusBar_SetText($hStatus,"Backing up BootSector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3], 2)
	$bkp = "bsdisk" & $USBdrives[$trg][2] & "part" & $USBdrives[$trg][3] & "-" & $dt & ".dat"
	$trggrub = "(hd" & $USBdrives[$trg][2] & "," & $USBdrives[$trg][3] & ")"
	;MsgBox(0,"", " -s=" & $bkp & " -t " & $trggrub)
	RunWait('"' & $_ScriptDir & "\files\grub4dos\grubinst.exe" & '" ' & "-s=" & $bkp & " -t " & $trggrub, $_ScriptDir, @SW_HIDE)
	Sleep(2000)
;	Logging(FileRead(@TempDir & "\grbts.tmp"))
	If Not FileExists($_ScriptDir & "\" & $bkp) Then
		MsgBox(16, "Fatal error", "grubinst.exe could not make a backup of bootsector " & $trggrub & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("grubinst.exe could not make a backup of bootsector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3])
		Quit()
	EndIf
	Logging("Backed up BootSector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3])
	FileMove($_ScriptDir & "\" & $bkp, $_ScriptDir & "\backups\", 9)
	If FileExists($_ScriptDir & "\" & $bkp) Then
		FileDelete($_ScriptDir & "\" & $bkp)
		RunWait(@ComSpec & " /c move /y " & '"' & $_ScriptDir & "\" & $bkp & '" "' & $_ScriptDir & "\backups\" & $bkp & '"', $_ScriptDir, @SW_SHOW)
	EndIf
EndFunc ;==>BackUp
;===================================================================================================
Func InstallGrub()
	Logging ("Installing grub4dos BS/MBR and files")
	Local $trggrub, $bkp
	$trg = $USBdrives[0][4]
	BackUp($trg)
	;$bkp = "mbrdisk" & $USBdrives[$trg][2] & "-" & $dt & ".dat"
	;FileMove($bkp, $_ScriptDir & "\backups\", 9)
	;$bkp = "bsdisk" & $USBdrives[$trg][2] & "part" & $USBdrives[$trg][3] & "-" & $dt & ".dat"
	;FileMove($bkp, $_ScriptDir & "\backups", 9)
	$trggrub = "(hd" & $USBdrives[$trg][2] & "," & $USBdrives[$trg][3] & ")"
	If CheckGrubBS($trg) + CheckGrubMBR($trg) < 1 Then
		Logging("Installing grub4dos bootsector to " & $trggrub)
		Logging($_ScriptDir & "\files\grub4dos\grubinst.exe " & $trggrub)
		_GUICtrlStatusBar_SetText($hStatus,"Installing grub4dos bootsector to " & $trggrub, 2)
		If $USBdrives[$trg][7] = "NTFS" Then
			Logging ("Launching fsutil volume dismount" & " " & $USBdrives[$trg][0])
			RunWait("fsutil volume dismount" & " " & $USBdrives[$trg][0], "", @SW_HIDE)
			Sleep(200)
		EndIf
		RunWait('"' & $_ScriptDir & "\files\grub4dos\grubinst.exe" & '" ' & $trggrub, $_ScriptDir, @SW_HIDE)
		RunWait('"' & $_ScriptDir & "\files\grub4dos\touchdrv.exe" & '"' & " " & $USBdrives[$trg][0], "", @SW_HIDE)
		Sleep(4000)
		;Logging ("Launching " & '"' & $_ScriptDir & "\files\tools\RemoveDrive" & '"' & " " & $USBdrives[$trg][0] & " -l -b")
		;RunWait('"' & $_ScriptDir & "\files\tools\RemoveDrive" & '"' & " " & $USBdrives[$trg][0] & " -l -b", "", @SW_HIDE)
		;MsgBox(0, "Please remove and reinsert your USB disk", "Please remove and reinsert your USB disk." & @CRLF & "Press OK when ready.")
		;Sleep(2000)
		;RunWait(@ComSpec & " /c sync.exe " & StringLeft($TargetDrive, 1) & " " & StringLeft($TargetActive, 1), $_ScriptDir & "\files\tools\", @SW_HIDE)
		;Sleep(1000)
		If CheckGrubBS($trg) = 0 Then 
			Logging("Could not install grub4dos bootsector")
			$msg = MsgBox(48+1, "Warning", "Could not install grub4dos bootsector!" & @CRLF & "Will attempt to install it to MBR...", 10)
			If $msg = 1 Or $msg = -1 Then
				$trggrub = "(hd" & $USBdrives[$trg][2] & ")"
				Logging ("Installing grub4dos MBR to " & $trggrub)
				Logging($_ScriptDir & "\files\grub4dos\grubinst.exe " & $trggrub)
				_GUICtrlStatusBar_SetText($hStatus,"Installing grub4dos MBR to " & $trggrub, 2)
				If $USBdrives[$trg][7] = "NTFS" Then 
					RunWait("fsutil volume dismount" & " " & $USBdrives[$trg][0], "", @SW_HIDE)
					Sleep(200)
				EndIf
				RunWait('"' & $_ScriptDir & "\files\grub4dos\grubinst.exe" & '" ' & $trggrub, $_ScriptDir, @SW_HIDE)
				RunWait('"' & $_ScriptDir & "\files\grub4dos\touchdrv.exe" & '"' & " " & $USBdrives[$trg][0], "", @SW_HIDE)
				Sleep(4000)
				;Logging ("Launching " & '"' & $_ScriptDir & "\files\tools\RemoveDrive" & '"' & " " & $USBdrives[$trg][0] & " -l -b")
				;RunWait('"' & $_ScriptDir & "\files\tools\RemoveDrive" & '"' & " " & $USBdrives[$trg][0] & " -l -b", "", @SW_HIDE)
				;MsgBox(0, "Please remove and reinsert your USB disk", "Please remove and reinsert your USB disk." & @CRLF & "Press OK when ready.")
				;Sleep(2000)
				If CheckGrubMBR($trg) = 0 Then
					Logging("Could not install grub4dos MBR, aborting...")
					MsgBox(48, "Fatal error!", "Could not install grub4dos MBR!" & @CRLF & "Please ask for help in support forum @ msfn.org" & @CRLF & "Aborting in 10 seconds...", 10)
					Quit()
				EndIf
			
			Else
				Logging ("Installing grub4dos MBR refused, aborting...")
				Quit()
			EndIf
		EndIf
	EndIf
	
	
	If Not FileExists($TargetActive & "\grldr") Then 
		Logging("Copying grldr")
		FileCopy($_ScriptDir & "\files\grub4dos\grldr", $TargetActive, 9)
	EndIf
	If Not FileExists($TargetActive & "\menu.lst") Then 
		Logging("Copying menu.lst")
		FileCopy($_ScriptDir & "\files\grub4dos\menu.lst", $TargetActive, 9)		
	EndIf
	If Not FileExists($TargetActive & "\default") Then 
		Logging("Copying default")
		FileCopy($_ScriptDir & "\files\grub4dos\default", $TargetActive, 9)
	EndIf
	Logging("grub4dos installed")
	_GUICtrlStatusBar_SetText($hStatus,"grub4dos installed", 2)
EndFunc ;==>InstallGrub
;===================================================================================================
Func Checkgrub()
	Logging("Checking if grub4dos is installed properly")
	$trg = $USBdrives[0][4]
	If (FileExists($TargetActive & "\grldr") + FileExists($TargetActive & "\menu.lst") + FileExists($TargetActive & "\default")) < 3 Or (CheckGrubBS($trg) + CheckGrubMBR($trg) < 1) Then
		Logging ("grub4dos BS/MBR and files are NOT installed properly")
		Return 0
	Else
		Logging ("grub4dos BS/MBR and files are installed properly")
		Return 1
	EndIf
EndFunc  ;=>Checkgrub
;===================================================================================================
Func CheckGrubBS($trg)
	Local $trggrub, $bkp, $grubbs
	;_ArrayDisplay($USBdrives)
	Logging("Checking for grldr string in BootSector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3])
	_GUICtrlStatusBar_SetText($hStatus,"Checking BootSector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3], 2)
	$bkp = "bsdisk" & $USBdrives[$trg][2] & "part" & $USBdrives[$trg][3] & "-" & $dt & "check.dat"
	$trggrub = "(hd" & $USBdrives[$trg][2] & "," & $USBdrives[$trg][3] & ")"
	;MsgBox(0,"", " -s=" & $bkp & " -t " & $trggrub)
	RunWait('"' & $_ScriptDir & "\files\grub4dos\grubinst.exe" & '" ' & "-s=" & $bkp & " -t " & $trggrub, $_ScriptDir, @SW_HIDE)
	Sleep(2000)
	If Not FileExists($_ScriptDir & "\" & $bkp) Then
		MsgBox(16, "Fatal error", "grubinst.exe could save bootsector " & $trggrub & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("grubinst.exe could not save bootsector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3])
		Quit()
	EndIf
	Logging("Saved BootSector of disk #" & $USBdrives[$trg][2] & " partition #" & $USBdrives[$trg][3])
	$file = FileOpen($_ScriptDir & "\" & $bkp, 16)
	If $file = -1 Then
		MsgBox(16, "Fatal error", "Unable to open bootsector file." & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("Unable to open bootsector file." & @CRLF & "Exiting in 10 seconds...")
		Quit()
	EndIf
	$grubbs = FileRead($file)
	If @error  Then 
		MsgBox(16, "Fatal error", "Unable to read bootsector file." & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("Unable to read bootsector file." & @CRLF & "Exiting in 10 seconds...")
		Quit()
	EndIf
	FileClose($file)
	Sleep(1000)
	FileDelete($_ScriptDir & "\" & $bkp)
	If FileExists($_ScriptDir & "\" & $bkp) Then
		FileDelete($_ScriptDir & "\" & $bkp)
		RunWait(@ComSpec & " /c del /f /q " & '"' & $_ScriptDir & "\" & $bkp & '" "' & $_ScriptDir & "\backups\" & $bkp & '"', $_ScriptDir, @SW_HIDE)
	EndIf
	;MsgBox(0,"",$grubbs)
	If Not StringInStr($grubbs, "4E6F2067726C6472", 0) Then
		Logging("Grub4dos bootsector not found")
		Return 0
	Else
		Logging("Grub4dos bootsector found")
		Return 1
	EndIf
	;MsgBox(0,"",$grubbs)
EndFunc ;==>CheckGrubBS
;===================================================================================================
Func CheckGrubMBR($trg)
	Local $trggrub, $bkp, $grubmbr, $file
	;_ArrayDisplay($USBdrives)
	Logging("Checking for grldr string in MBR of disk #" & $USBdrives[$trg][2])
	_GUICtrlStatusBar_SetText($hStatus,"Checking MBR of disk #" & $USBdrives[$trg][2], 2)
	$bkp = "mbrdisk" & $USBdrives[$trg][2] & "-" & $dt & "check.dat"
	$trggrub = "(hd" & $USBdrives[$trg][2] & ")"
	;Logging ($_ScriptDir & "\files\grub4dos\grubinst.exe -s=" & $bkp & " -t " & $trggrub)
	RunWait('"' & $_ScriptDir & "\files\grub4dos\grubinst.exe" & '" ' & "-s=" & $bkp & " -t " & $trggrub, $_ScriptDir, @SW_HIDE)
	Sleep(2000)
	If Not FileExists($_ScriptDir & "\" & $bkp) Then
		MsgBox(16, "Fatal error", "grubinst.exe could save MBR of disk #" & $USBdrives[$trg][2] & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("grubinst.exe could not save MBR of disk #" & $USBdrives[$trg][2])
		Quit()
	EndIf
	Logging("Saved MBR of disk #" & $USBdrives[$trg][2])
	$file = FileOpen($_ScriptDir & "\" & $bkp, 16)
	If $file = -1 Then
		MsgBox(16, "Fatal error", "Unable to open MBR file." & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("Unable to open MBR file." & @CRLF & "Exiting in 10 seconds...")
		Quit()
	EndIf
	$grubmbr = FileRead($file)
	If @error  Then 
		MsgBox(16, "Fatal error", "Unable to read MBR file." & @CRLF & "Exiting in 10 seconds...", 10)
		Logging("Unable to read MBR file." & @CRLF & "Exiting in 10 seconds...")
		Quit()
	EndIf
	FileClose($file)
	Sleep(1000)
	FileDelete($_ScriptDir & "\" & $bkp)
	If FileExists($_ScriptDir & "\" & $bkp) Then
		FileDelete($_ScriptDir & "\" & $bkp)
		RunWait(@ComSpec & " /c del /f /q " & '"' & $_ScriptDir & "\" & $bkp & '" "' & $_ScriptDir & "\backups\" & $bkp & '"', $_ScriptDir, @SW_HIDE)
	EndIf
	;MsgBox(0,"",StringLeft($grubmbr, 8))
	;ConsoleWrite(StringLeft($grubmbr, 8))
	If Not StringInStr(StringLeft($grubmbr, 8), "0xEB5E80", 0) Then
		Logging("Grub4dos MBR not found")
		Return 0
	Else
		Logging("Grub4dos MBR found")
		Return 1
	EndIf
	;MsgBox(0,"",$grubbs)
EndFunc ;==>CheckGrubMBR
;===================================================================================================
Func _FileCopy($fromFile,$todirectory)
    Local $FOF_RESPOND_YES = 16
    Local $FOF_SIMPLEPROGRESS = 256
    $winShell = ObjCreate("shell.application")
    $winShell.namespace($todirectory).CopyHere($fromFile)
EndFunc

;===================================================================================================
Func _CopyDirWithProgress($aFileList, $sDestDir, $sl, $NrAllFiles, $CopyFlag = 0)
;original author: ezzetabi
Local $LocalNumberFiles, $iCopiedSize = 0, $fProgress = 0, $fProgressAll, $c, $FileName, $iOutPut = 0, $sLost = '', $sError, $i, $ddfn
;$sOriginalDir and $sDestDir are quite selfexplanatory...
  ;This func returns:
  ; -1 in case of critical error, bad original or destination dir
  ;  0 if everything went all right
  ; >0 is the number of file not copied and it makes a log file
  ;  if in the log appear as error message '0 file copied' it is a bug of some windows' copy command that does not redirect output...
	If StringRight($sDestDir, 1) <> '\' Then $sDestDir = $sDestDir & '\'
	_GUICtrlStatusBar_SetText($hStatus,$NrAllFiles, 4)
	If $aFileList[0] = 0 Then
		SetError(1)
		Return -1
	EndIf
	If FileExists($sDestDir) Then
		If Not StringInStr(FileGetAttrib($sDestDir), 'd') Then
			SetError(2)
			Return -1
		EndIf
	Else
		DirCreate($sDestDir)
		If Not FileExists($sDestDir) Then
			SetError(2)
			Return -1
		EndIf
	EndIf
	$LocalNumberFiles = $aFileList[0]
	Opt("GUIOnEventMode", 0)
	For $c = 1 To $aFileList[0]
		If StringInStr($aFileList[$c], "menu.lst", 1) Then ContinueLoop
		$NrCpdFiles += 1
		$msg = GUIGetMsg()
		If $msg = $GO  Then 
			;GUICtrlSetData($Progress, 0)
			Opt("GUIOnEventMode", 1)
			GUICtrlSetData($Go, "GO")
			_GUICtrlStatusBar_SetText($hStatus, "Stop pressed", 2)
			Logging("Stop pressed")
			Return -2
		ElseIf $msg = $EXIT Then
			Logging("Program aborted during copying...")
			Quit()
		Else
			$FileName = StringTrimLeft($aFileList[$c], $sl)
			;GUICtrlSetData($Progress, $fProgress)
			GUICtrlSetData($ProgressAll, $fProgressAll)
			_GUICtrlStatusBar_SetText($hStatus, StringRight($aFileList[$c], 40), 2)
			_GUICtrlStatusBar_SetText($hStatus,$NrCpdFiles, 3)
			$ddfn = StringReplace($sDestDir & $FileName, "\\", "\")
			If StringInStr(FileGetAttrib($aFileList[$c]), 'd') Then
				DirCreate($ddfn)
			Else
				If $sync = 1 And StringInStr($ddfn, "$.~") > 0 Then 
					If FileExists($ddfn) Then
						Logging($ddfn & " exists, skipping")
						ContinueLoop
					EndIf
				EndIf		
				Logging($aFileList[$c] & "---> " & $ddfn)
				If Not FileCopy($aFileList[$c], $ddfn, $CopyFlag + 8) Then
					If Not FileCopy($aFileList[$c], $ddfn, $CopyFlag + 8) Then ;Tries a second time
						If RunWait(@ComSpec & ' /c copy "' & $aFileList[$c] & '" "' & $ddfn & '">' & @TempDir & '\o.tmp', '', @SW_HIDE)=1 Then
							$sError = FileReadLine(@TempDir & '\o.tmp',1)
							Logging("ERROR!!!--- not copied:" & $aFileList[$c] & '  ' & $sError) 
							;$iOutPut = $iOutPut + 1
							;$sLost = $sLost & $aFileList[$c] & '  ' & $sError & @CRLF
							FileDelete(@TempDir & '\o.tmp')
						EndIf
					EndIf
				EndIf
			;FileSetAttrib($sDestDir & $FileName, "+A-RSH");<- Comment this line if you do not want attribs reset.
			$fProgress = Int($c * 100 / $LocalNumberFiles)
			$fProgressAll = Int($NrCpdFiles * 100/ $NrAllFiles)
			EndIf
		EndIf
   Next
 $LoopContinue = 0
 Opt("GUIOnEventMode", 1)
   ;ProgressOff()
  
;	If $sLost <> '' Then;tries to write the log somewhere.
;		If FileWrite($_ScriptDir & 'notcopied.txt',$sLost) = 0 Then FileWrite(@WorkingDir & '\notcopied.txt',$sLost)
;	EndIf
	Return $iOutPut
EndFunc  ;==>_CopyDirWithProgress
;===================================================================================================

Func _FileSearch($sPath, $sFilter = '*.*', $iFlag = 0, $sExclude = '', $iRecurse = True)
;===============================================================================
;
; Description:      lists all or preferred files and or folders in a specified path (Similar to using Dir with the /B Switch)
; Syntax:           _FileListToArrayEx($sPath, $sFilter = '*.*', $iFlag = 0, $sExclude = '')
; Parameter(s):        $sPath = Path to generate filelist for
;                    $sFilter = The filter to use. Search the Autoit3 manual for the word "WildCards" For details, support now for multiple searches
;                            Example *.exe; *.txt will find all .exe and .txt files
;                   $iFlag = determines weather to return file or folders or both.
;                    $sExclude = exclude a file from the list by all or part of its name
;                            Example: Unins* will remove all files/folders that start with Unins
;                        $iFlag=0(Default) Return both files and folders
;                       $iFlag=1 Return files Only
;                        $iFlag=2 Return Folders Only
;
; Requirement(s):   None
; Return Value(s):  On Success - Returns an array containing the list of files and folders in the specified path
;                        On Failure - Returns the an empty string "" if no files are found and sets @Error on errors
;                        @Error or @extended = 1 Path not found or invalid
;                        @Error or @extended = 2 Invalid $sFilter or Invalid $sExclude
;                       @Error or @extended = 3 Invalid $iFlag
;                         @Error or @extended = 4 No File(s) Found
;
; Author(s):        SmOke_N
; Note(s):            The array returned is one-dimensional and is made up as follows:
;                    $array[0] = Number of Files\Folders returned
;                    $array[1] = 1st File\Folder
;                    $array[2] = 2nd File\Folder
;                    $array[3] = 3rd File\Folder
;                    $array[n] = nth File\Folder
;
;                    All files are written to a "reserved" .tmp file (Thanks to gafrost) for the example
;                    The Reserved file is then read into an array, then deleted
;===============================================================================
    If Not FileExists($sPath) Then Return SetError(1, 1, '')
    If $sFilter = -1 Or $sFilter = Default Then $sFilter = '*.*'
    If $iFlag = -1 Or $iFlag = Default Then $iFlag = 0
    If $sExclude = -1 Or $sExclude = Default Then $sExclude = ''
    Local $aBadChar[6] = ['\', '/', ':', '>', '<', '|']
    $sFilter = StringRegExpReplace($sFilter, '\s*;\s*', ';')
    If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
    For $iCC = 0 To 5
        If StringInStr($sFilter, $aBadChar[$iCC]) Or _
            StringInStr($sExclude, $aBadChar[$iCC]) Then Return SetError(2, 2, '')
    Next
    If StringStripWS($sFilter, 8) = '' Then Return SetError(2, 2, '')
    If Not ($iFlag = 0 Or $iFlag = 1 Or $iFlag = 2) Then Return SetError(3, 3, '')
    Local $oFSO = ObjCreate("Scripting.FileSystemObject"), $sTFolder
    $sTFolder = $oFSO.GetSpecialFolder(2)
    Local $hOutFile = @TempDir & $oFSO.GetTempName
    If Not StringInStr($sFilter, ';') Then $sFilter &= ';'
    Local $aSplit = StringSplit(StringStripWS($sFilter, 8), ';'), $sRead, $sHoldSplit
    For $iCC = 1 To $aSplit[0]
        If StringStripWS($aSplit[$iCC],8) = '' Then ContinueLoop
        If StringLeft($aSplit[$iCC], 1) = '.' And _
            UBound(StringSplit($aSplit[$iCC], '.')) - 2 = 1 Then $aSplit[$iCC] = '*' & $aSplit[$iCC]
        $sHoldSplit &= '"' & $sPath & $aSplit[$iCC] & '" '
    Next
    $sHoldSplit = StringTrimRight($sHoldSplit, 1)
       
    If $iRecurse Then
        RunWait(@Comspec & ' /c dir /b /s /a ' & $sHoldSplit & ' > "' & $hOutFile & '"', '', @SW_HIDE)
    Else
        RunWait(@ComSpec & ' /c dir /b /a ' & $sHoldSplit & ' /o-e /od > "' & $hOutFile & '"', '', @SW_HIDE)
    EndIf
    $sRead &= FileRead($hOutFile)
    If Not FileExists($hOutFile) Then Return SetError(4, 4, '')
    FileDelete($hOutFile)
    If StringStripWS($sRead, 8) = '' Then SetError(4, 4, '')
    Local $aFSplit = StringSplit(StringTrimRight(StringStripCR($sRead), 1), @LF)
    Local $sHold, $a_AnsiFName
    For $iCC = 1 To $aFSplit[0]
        ; translate DOS filenames from OEM to ANSI
        $a_AnsiFName = DllCall('user32.dll','Int','OemToChar','str',$aFSplit[$iCC],'str','')
        If @error=0 Then $aFSplit[$iCC] = $a_AnsiFName[2]

        If $sExclude And StringLeft($aFSplit[$iCC], _
            StringLen(StringReplace($sExclude, '*', ''))) = StringReplace($sExclude, '*', '') Then ContinueLoop
        Switch $iFlag
            Case 0
                If StringRegExp($aFSplit[$iCC], '\w:\\') = 0 Then
                    $sHold &= $sPath & $aFSplit[$iCC] & Chr(1)
                Else
                    $sHold &= $aFSplit[$iCC] & Chr(1)
                EndIf
            Case 1
                If StringInStr(FileGetAttrib($sPath & '\' & $aFSplit[$iCC]), 'd') = 0 And _
                    StringInStr(FileGetAttrib($aFSplit[$iCC]), 'd') = 0 Then
                    If StringRegExp($aFSplit[$iCC], '\w:\\') = 0 Then
                        $sHold &= $sPath & $aFSplit[$iCC] & Chr(1)
                    Else
                        $sHold &= $aFSplit[$iCC] & Chr(1)
                    EndIf
                EndIf
            Case 2
                If StringInStr(FileGetAttrib($sPath & '\' & $aFSplit[$iCC]), 'd') Or _
                    StringInStr(FileGetAttrib($aFSplit[$iCC]), 'd') Then
                    If StringRegExp($aFSplit[$iCC], '\w:\\') = 0 Then
                        $sHold &= $sPath & $aFSplit[$iCC] & Chr(1)
                    Else
                        $sHold &= $aFSplit[$iCC] & Chr(1)
                    EndIf
                EndIf
        EndSwitch
    Next
    If StringTrimRight($sHold, 1) Then Return StringSplit(StringTrimRight($sHold, 1), Chr(1))
    Return SetError(4, 4, '')
EndFunc
;===================================================================================================
Func _Quick_Sort(ByRef $SortArray, $First, $Last);Larry's code
   Dim $Low, $High
   Dim $Temp, $List_Separator
  
   $Low = $First
   $High = $Last
   $List_Separator = StringLen($SortArray[ ($First + $Last) / 2])
   Do
		While (StringLen($SortArray[$Low]) < $List_Separator)
			$Low = $Low + 1
		WEnd
		While (StringLen($SortArray[$High]) > $List_Separator)
			$High = $High - 1
		WEnd
		If ($Low <= $High) Then
			$Temp = $SortArray[$Low]
			$SortArray[$Low] = $SortArray[$High]
			$SortArray[$High] = $Temp
			$Low = $Low + 1
			$High = $High - 1
		EndIf
	Until $Low > $High
   If ($First < $High) Then _Quick_Sort($SortArray, $First, $High)
   If ($Low < $Last) Then _Quick_Sort($SortArray, $Low, $Last)
EndFunc  ;==>_Quick_Sort

;===================================================================================================
Func Logging($log_text)
	; Check if file opened for writing OK
	If $logfile = -1 Then
		MsgBox(1+16, "Error", "Unable to write to log file. Exiting in 10 seconds...", 10)
		Exit
	EndIf
	FileWriteLine($logfile, _NowCalc() & "- " & $log_text & @CRLF)
EndFunc ;==>_Logging()

;===================================================================================================
Func TogglePause()
    $Paused = NOT $Paused
    While $Paused
        Sleep(100)
	WEnd
EndFunc ;==>TogglePause()
;===================================================================================================
Func PatchSrc()
	Local $i, $trg1, $trg2, $str1, $str2, $str3, $str4, $j, $k, $l
	For $i = 0 to 9
		$trg1 = $TargetDrive & "\$WIN_0" & $i & "$.~BT"
		$trg2 = $TargetDrive & "\$WIN_0" & $i & "$.~LS"
		$str1 = "$WIN_0" & $i & "$.~BT"
		$str2 = "$WIN_0" & $i & "$.~LS"
		If FileExists($trg1) + FileExists($trg2) = 0 Then ExitLoop
	Next
	Logging("Renaming $WIN_NT$.~BT to " & $str1 )
	_GUICtrlStatusBar_SetText($hStatus,"Renaming $WIN_NT$.~BT to " & $str1 , 2)
	DirMove($TargetDrive & "\$WIN_NT$.~BT", $trg1, 2)
	Logging("Renaming $WIN_NT$.~LS to " & $str2 )
	_GUICtrlStatusBar_SetText($hStatus,"Renaming $WIN_NT$.~LS to " & $str2 , 2)
	DirMove($TargetDrive & "\$WIN_NT$.~LS", $trg2, 2)
	Logging("Renaming txtsetup.sif to " & "txtset0" & $i & ".sif" )
	_GUICtrlStatusBar_SetText($hStatus,"Renaming txtsetup.sif to " & "txtset0" & $i & ".sif" , 2)
	FileMove($TargetDrive & "\txtsetup.sif", $TargetDrive & "\txtset0" & $i & ".sif", 1)
	Logging("Deleting txtsetup.sif")
	_GUICtrlStatusBar_SetText($hStatus,"Deleting txtsetup.sif", 2)
	FileDelete($TargetDrive & "\txtsetup.sif")
	If FileExists($trg1 & "\setupldr.bin") Then
		Logging("Patching " & $trg1 & "\setupldr.bin")
		_GUICtrlStatusBar_SetText($hStatus,"Patching " & $trg1 & "\setupldr.bin", 2)		
		HexReplace($trg1 & "\setupldr.bin", "$WIN_NT$.~BT", $str1, 0, 16)
		HexReplace($trg1 & "\setupldr.bin", "txtsetup.sif", "txtset0" & $i & ".sif", 0, 16)
		Logging("Fixing checksum check in " & $trg1 & "\setupldr.bin")
		_GUICtrlStatusBar_SetText($hStatus,"Fixing checksum check in " & $trg1 & "\setupldr.bin", 2)
		HexReplace($trg1 & "\setupldr.bin", "46DA7403E908", "46DAEB1AE908", 1, 16, 1)
	EndIf
	If FileExists($trg1 & "\setupdd.sy_") Then
		RunWait("expand -r " & $trg1 & "\setupdd.sy_", "", @SW_HIDE)
		$str3 = _StringToHex("$win_nt$.~ls")
		$str4 = _StringToHex("$win_0" & $i & "$.~ls")
		$j = StringLen($str3)
		$k = 0
		For $l = 2 To $j Step 2
			$str3 = _StringInsert( $str3, Hex(0,2), $l + $k)
			$k = $k + 2
		Next
		$j = StringLen($str4)
		$k = 0
		For $l = 2 To $j Step 2
			$str4 = _StringInsert( $str4, Hex(0,2), $l + $k)
			$k = $k + 2
		Next
		Logging("Patching " & $trg1 & "\setupdd.sys")
		_GUICtrlStatusBar_SetText($hStatus,"Patching " & $trg1 & "\setupdd.sys", 2)
		HexReplace($trg1 & "\setupdd.sys", $str3, $str4, 0, 16, 1)
		FileDelete($trg1 & "\setupdd.sy_")
		Logging("Fixing checksum check in " & $trg1 & "\setupdd.sys")
		_GUICtrlStatusBar_SetText($hStatus,"Fixing checksum check in " & $trg1 & "\setupdd.sys", 2)
		FileCopy($_ScriptDir & "\files\winsetup\modifype.exe", $trg1, 0)
		RunWait(@ComSpec & " /c " & "MODIFYPE.EXE setupdd.sys -c", $trg1, @SW_HIDE)
		FileDelete($trg1 & "\modifype.exe")
		Logging("Compressing " & $trg1 & "\setupdd.sys")
		_GUICtrlStatusBar_SetText($hStatus,"Compressing " & $trg1 & "\setupdd.sys", 2)
		RunWait(@ComSpec & " /c makecab.exe " & "setupdd.sys" & " setupdd.sy_", $trg1, @SW_HIDE)
		FileDelete($trg1 & "\setupdd.sys")
	EndIf
	Logging("Patching cmd and boot files")
	_GUICtrlStatusBar_SetText($hStatus,"Patching cmd and boot files", 2)
	If FileExists($TargetActive & "\winsetup.lst") Then 
		HexReplace($TargetActive & "\winsetup.lst", "(hd0," & $USBdrives[$USBdrives[0][1]][3] & ")/$WIN_NT$.~BT", "(hd0," & $USBdrives[$USBdrives[0][1]][3] & ")/" & $str1)
	EndIf
	If FileExists($trg2 & "\I386\undoren.cmd") Then 
		HexReplace($trg2 & "\I386\undoren.cmd", "WIN_NT", "WIN_0" & $i)
		HexReplace($trg2 & "\I386\undoren.cmd", "txtsetup", "txtset0" & $i)
	EndIf
	If FileExists($trg2 & "\I386\binifix5.cmd") Then 
		HexReplace($trg2 & "\I386\binifix5.cmd", "WIN_NT", "WIN_0" & $i)
		HexReplace($trg2 & "\I386\binifix5.cmd", "txtsetup", "txtset0" & $i)
	EndIf
	If FileExists($trg2 & "\AMD64\undoren.cmd") Then 
		HexReplace($trg2 & "\AMD64\undoren.cmd", "WIN_NT", "WIN_0" & $i)
		HexReplace($trg2 & "\AMD64\undoren.cmd", "txtsetup", "txtset0" & $i)
	EndIf
	If FileExists($trg2 & "\AMD64\binifix5.cmd") Then 
		HexReplace($trg2 & "\AMD64\binifix5.cmd", "WIN_NT", "WIN_0" & $i)
		HexReplace($trg2 & "\AMD64\binifix5.cmd", "txtsetup", "txtset0" & $i)
	EndIf
	If FileExists($TargetDrive & "\OEM\") Then
		Logging("Fixing OEM folder")
		_GUICtrlStatusBar_SetText($hStatus,"Fixing OEM folder", 2)
		DirMove($TargetDrive & "\OEM\",$TargetDrive & "\OEM0" & $i & "\", 1)
	EndIf
	If FileExists($trg2 & "\I386\presetup.cmd") Then 
		HexReplace($trg2 & "\I386\presetup.cmd", "\OEM", "\OEM0" & $i)
		HexReplace($trg2 & "\I386\presetup.cmd", "WIN_NT", "WIN_0" & $i)
	EndIf
	If FileExists($trg2 & "\AMD64\presetup.cmd") Then 
		HexReplace($trg2 & "\AMD64\presetup.cmd", "\OEM", "\OEM0" & $i)
		HexReplace($trg2 & "\AMD64\presetup.cmd", "WIN_NT", "WIN_0" & $i)
	EndIf
	
	Logging("Patching completed")
	_GUICtrlStatusBar_SetText($hStatus,"Patching completed", 2)
EndFunc
;========================================================================================================
Func HexReplace($fl, $str1, $str2, $flag = 0, $bin = 0, $ind = 0)
	Local $hOut, $src, $file
	;flag- The number of times to replace the searchstring, 0 for all
	;$bin- 16 for hex editing
	Logging("HEX editing "& $fl)
	If $bin = 16 And $ind = 0 Then 
		$str1 = _StringToHex($str1)
		$str2 = _StringToHex($str2)
	EndIf
	$file = FileOpen($fl, $bin)
	$src = FileRead($file)
	FileClose($file)
	FileMove($fl, $fl & ".bak", 8)
	If $fl = -1 Then
		MsgBox(16, "Error", "Unable to open " & $fl & " for editing, Aborting in 10 seconds...", 10)
		Logging("Unable to open " & $fl & " for editing, Aborting in 10 seconds...")
		Exit
	EndIf
	$src = StringReplace($src, $str1, $str2, $flag)
	If $src = "" Then 
		MsgBox(16, "Error", "Something wont wrong whille editing " & $fl)
		Logging("Something wont wrong whille editing " & $fl)
	EndIf
	$hOut = FileOpen($fl, $bin + 2)
    FileWrite($hOut , $src)
    FileClose($hOut)
	Return @extended
EndFunc
;=========================================================================================================

Func IniWriteLine($file, $section, $line)
	Local $contents, $i, $out
	$contents = IniReadSection($file, $section)
	If @error = 1 Then 
		FileWriteLine($file, @CRLF & "[" & $section & "]" & @CRLF & $line)
	Else
		For $i = 1 To $contents[0][0]
			$out &= $contents[$i][0] & "=" & $contents[$i][1] & @CRLF
		Next
		$out &= $line & @CRLF
		IniWriteSection($file, $section, $out)
	EndIf
EndFunc ;==>IniWriteLine
;=========================================================================================================
Func InstallSysLinux()
	Local $msg
	Logging("Preparing SysLinux bootsector")
	Logging(@ComSpec & " /c syslinux.exe -rf " & $TargetDrive & " syslin.dat")
	_GUICtrlStatusBar_SetText($hStatus,"Launching syslinux.exe", 2)
	RunWait(@ComSpec & " /c syslinux.exe -f " & $TargetDrive & " " & $TargetDrive & "\syslin.dat", $_ScriptDir & "\files\syslinux", @SW_HIDE)
	Sleep(2000)
	If FileExists($TargetDrive & "\syslin.dat") + FileExists($TargetDrive & "\ldlinux.sys") < 2 Then
		Logging("Something wont wrong whille preparing SysLinux bootsector")
		$msg = MsgBox(16 + 2, "Error", "Something went wrong whille preparing SysLinux bootsector" & @CRLF & "Could not find syslin.dat or syslinux.sys")
		If $msg = 3 Then Quit()
		If $msg = 4 Then InstallSysLinux()
		If $msg = 5 Then Return
	EndIf
	$menulst = FileOpen($TargetActive & "\menu.lst", 1)
	FileWriteLine($menulst, @CRLF & "title Start SysLinux bootsector from partition " & $USBdrives[$USBdrives[0][1]][3])
	FileWriteLine($menulst, "root (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")")
	FileWriteLine($menulst, "chainloader (hd0," & $USBdrives[$USBdrives[0][1]][3] & ")/syslin.dat" & @CRLF)
	Logging("SysLinux installed")
EndFunc ;==>InstallSysLinux()
;=========================================================================================================
Func ArrayMerge($amArray1, $amArray2)
;$amArray1: Array to add to
;$amArray2: Array to merge into previous
    Local $tempArray = $amArray1
    Local $amElements = Ubound($tempArray) + Ubound($amArray2)
    Redim $tempArray[$amElements]
    Local $amCount = 0
    For $X = Ubound($amArray1) to $amElements - 1
        $tempArray[$X] = $amArray2[$amCount]
        $amCount += 1
    Next
	$tempArray[0] = $amArray1[0] + $amArray2[0]
    Return $tempArray
EndFunc
;========================================================================================================
Func DeDupe(ByRef $sArray, $iDelete = 0)
	Local $i = 0, $k = 0, $j = 0, $TempLine, $dupes[1][3], $aTemp = $sArray
	For $i = $sArray[0] - 2 To 1
		$TempLine = $sArray[$i]
		If $TempLine = "" Then ContinueLoop
		For $k = $i + 1 To $sArray[0] - 1
			If $TempLine = $sArray[$k] Then 
				If $iDelete = 1 Then 
					_ArrayDelete($aTemp, $k)
					$aTemp[0] -= 1
				EndIf
				$j += 1
				ReDim $dupes[$j + 1][3]
				$dupes[0][0] = $j
				$dupes[$j][0] = $i
				$dupes[$j][1] = $k
				$dupes[$j][2] = $TempLine
			EndIf
		Next
	Next
	$sArray = $aTemp
	Return $dupes
EndFunc
;========================================================================================================
Func DisableMenus($endis)
		If $endis = 0 Then 
		$endis = $GUI_ENABLE
	Else
		$endis = $GUI_DISABLE
	EndIf
	GUICtrlSetState($SourceDir, $endis)
	GUICtrlSetState($Source, $endis)
	GUICtrlSetState($RefreshUSB, $endis)
	GUICtrlSetState($RMPrepUSB, $endis)
	GUICtrlSetState($RemovableRadio, $endis)
	GUICtrlSetState($FixedRadio, $endis)
	GUICtrlSetState($ComboBoxTarget, $endis)
	GUICtrlSetState($WinTarget, $endis)
	GUICtrlSetState($WinTargetDisk, $endis)
	GUICtrlSetState($WinTargetPartition, $endis)
	GUICtrlSetState($AddPECheck, $endis)
	GUICtrlSetState($AddPEBrowse, $endis)
	GUICtrlSetState($AddPeSource , $endis)
	GUICtrlSetState($AddVistaCheck, $endis)
	GUICtrlSetState($AddVistaBrowse, $endis)
	GUICtrlSetState($AddVistaSource, $endis)
	GUICtrlSetState($AddPMagicCheck, $endis)
	GUICtrlSetState($AddPMagicBrowse, $endis)
	GUICtrlSetState($AddPMagicSource, $endis)
	GUICtrlSetState($AddSysLinuxCheck, $endis)
	GUICtrlSetState($AddSysLinuxBrowse, $endis)
	GUICtrlSetState($AddSysLinuxSource, $endis)
	GUICtrlSetState($WinTargetAdd, $endis)
	GUICtrlSetState($TargetDiskAdd, $endis)
	GUICtrlSetState($TargetPartitionAdd , $endis)
	GUICtrlSetState($BootINIAddCheck, $endis)
	GUICtrlSetState($BootOnlyCheck, $endis)
EndFunc ;==>DisableMenus
;========================================================================================================
;===================================================================================================
Func Quit()
	_GUICtrlStatusBar_SetText($hStatus,"Removing TEMP folder", 2)
	DirRemove($_ScriptDir & "\TEMP", 1)
	Logging("---------------------------------Program quited-----------------------------------------------" & @CRLF)
	FileClose("WinSetupFromUSB.log")
	FileClose($menulst)
	Exit
EndFunc ;==>_Quit()

	
