@echo off

rem MkMigrateInf.cmd ver 1.1
rem created by cdob
rem
rem extract MountedDevices RemovableMedia from the registry
REM edited by Ilko- allow spaces in tarhet path, 24.May.2009

setlocal EnableExtensions EnableDelayedExpansion

set Drive=%~d1
if %Drive%.==. set Drive=%~d0

set FileName=%~2
if "%FileName%".==. set FileName=migrate_inf.txt

set MigrateDrive=U:
if not %~d3.==. set MigrateDrive=%~d3


set Value=
FOR /F "skip=2 tokens=1-2*" %%a IN ('reg query HKLM\System\MountedDevices /v \DosDevices\%Drive%') DO set Value=%%c
if %Value%.==. (echo drive settings %Drive% not found & goto :EOF)

set RemovableMedia=
if %Value:~48,56%.==520065006D006F007600610062006C0065004D006500640069006100. set RemovableMedia=1
set flag_search=1
set count_replace30=-1

set MigrateStr=%Value:~0,2%
set count=2

:begin_parse
  call :exec set MidStr=%%Value:~%count%,2%%
  if %MidStr%.==. goto :exit_parse
  
  rem special cases http://www.msfn.org/board/index.php?showtopic=131770
  rem use a fixed string RemovableMedia#7
  if DEFINED RemovableMedia if %count%.==108. if not %MidStr%.==37. ( 
    echo warning: MountedDevices does not contain RemovableMedia#7
    echo fixing to RemovableMedia#7
    set MidStr=37
  )
  rem set zero at RemovableMedia#?&*&0
  if DEFINED RemovableMedia if DEFINED flag_search if %count% GTR 112 if %MidStr%.==26. (
    set flag_search=
    set /a count4=!count!+4
    call :exec set MidStr2=%%Value:~!count4!,2%%
    if not !MidStr2!.==30. (
      echo warning: MountedDevices does not contain RemovableMedia#?^&*^&0
      set count_replace30=!count4!
    )
  )
  if %count% EQU %count_replace30% (
   echo fixing zero to RemovableMedia#?^&*^&0
   set count_replace30=-1
   set MidStr=30
  )

  set MigrateStr=%MigrateStr%,%MidStr%
  set /a count+=2 
  goto begin_parse
:exit_parse

(echo [Version]
echo Signature = "$Windows NT$"
echo. 
echo [Addreg]
echo HKLM,"SYSTEM\MountedDevices",,0x00000010
echo HKLM,"SYSTEM\ControlSet001\Control\StorageDevicePolicies","WriteProtect",0x00010001,1
echo HKLM,"SYSTEM\MountedDevices","\DosDevices\%MigrateDrive%",0x00030001,\
echo %MigrateStr%)>"%FileName%"

goto :EOF

:exec
  %*
goto :EOF